
/* Chart Locator.js
   Copyright 2013 Imatest LLC
 */

/*
    Declare global unit variables to use in various inputs
*/
var lightboxUnit       = '';
var chartUnit          = '';
var chartUnitMin       = '';
var chartRecommendUnit = 'in';

var cqiFilter = 'none';

var cookieExp = 30;

var charts = [];
var fisheye_error = false;

/*
    Declare arrays and objects for all metrics, options, properties, and sizes.
*/

var metrics = {
    'dfov':          null,              //diagonal field of view      2.5   may not be included
    'hfov':          null,
    'vfov':          null,
    'distortion':    null,
    'pixelwidth':    null,              //width in pixels           8
    'pixelheight':   null,              //height in pixels          7
    'megapixels':    null,
    'aspectratio':   null,
    'lenschart':     Infinity,          //testDistance              2
    'lenschart_min': null,
    'planewidth':    null,              //test width                4
    'planeheight':   null,              //test height               3
    'maximumlength': null,
    'maximumwidth':  null,              //maximum chart width       6
    'maximumheight': null,              //maximum chart height      5
    'boxwidth':      Infinity,          
    'boxheight':     Infinity           
};
var originalMetrics = {
    'lenschart':     null,
    'lenschart_min': null,
    'planewidth':    null,
    'planeheight':   null,
    'maximumlength': null,
    'maximumwidth':  null,
    'maximumheight': null,
    'boxwidth':      null,
    'boxheight':     null
};
var calculated = {
    'dfov':          false,
    'hfov':          false,
    'vfov':          false,
    'distortion':    false,
    'pixelwidth':    false,
    'pixelheight':   false,
    'megapixels':    false,
    'aspectratio':   false,
    'lenschart':     false,
    'lenschart_min': false,
    'planewidth':    false,
    'planeheight':   false,
    'boxwidth':      false,
    'boxheight':     false
};
/*//...var options = {
//...    "reflective":        true,
//...    "transmissive":      true,
//...    "squares":           0,
//...    "color":             false,
//...    "focus":             false,
//...    "distortion":        false,
//...    "signal_processing": false,
//...    "lightbox":          false,
//...    "substrate":         null,
//...    "contrast":          2
//...};
//... ADDED*/
var options = {
    "reflective":           true,
    "transmissive":         true,
//...    "lighting_eqp":         false,
//...    "test_fixtures":        false,
    "sharpness":            false,
    "noise":                false,
    "dynamic_range":        false,
    "color_accuracy":       false,
    "distortion":           false,
    "uniformity":           false,
    "blemishes":            false,
    "iso_sensitivity":      false,
    "chromatic_abberation": false,
    "flare":                false,
    "color_moire":          false,
    "artifacts":            false,
    "compression":          false,
    "dmax":                 false,
    "color_gamut":          false,
    "texture_detail":       false,
    "near_infrared":        false
};
/*/... END ADDED
//...var testItems = [
//...    "Color",
//...    //"Visual Focusing",
//...    "Signal Processing",
//...    "Lightbox"
//...];
//... ADDED*/
//...var eQuipments = [
//...    "Lighting Equipment",
//...    "Test Fixtures"
//...];
var testItems = [
    "Sharpness",
    "Noise",
    "Dynamic Range",
    "Color Accuracy",
    "Distortion",
    "Uniformity",
    "Blemishes",
    "ISO Sensitivity",
    "Chromatic Abberation",
    "Flare",
    "Color Moir&#233",
    "Artifacts",
    "Compression Losses",
    "Dmax - Maximum Density",
    "Color Gamut",
    "Texture Detail",
    "Near-Infrared"
];
/*/... END ADDED
//...var testItemIds = [
//...    "color",
//...    //"focus", 
//...    "signal_processing",
//...    "lightbox"
//...];
//... ADDED*/
//...var eQuipmentIds = [
//...    "lighting_eqp",
//...    "test_fixtures"
//...];
var testItemIds = [
    "sharpness",
    "noise",
    "dynamic_range",
    "color_accuracy",
    "distortion",
    "uniformity",
    "blemishes",
    "iso_sensitivity",
    "chromatic_abberation",
    "flare",
    "color_moire",
    "artifacts",
    "compression",
    "dmax",
    "color_gamut",
    "texture_detail",
    "near_infrared"
];
/*/... END ADDED*/
var substrateList = [
    'matte',
    'gloss',
    'inkjet',
    'lvt'
];
var substrateMTF = {
    "matte":  [5.28, 3.17, 1.24],
    "gloss":  [5.38, 3.06, 1.21],
    'inkjet': [4.68, 3.38, 1.52],
    'lvt':    [22.2, 16.2, 10.8]
};
var reflectSize5x7 = [
    'Medium: 22"x33"',
    'Large: 40"x59"',
    'X-Large: 42"x59"',
    'Small: 14"x20"',
    'X-Small: 8"x11"'
];
var reflectSize5x9 = [
    'Medium: 22"x39.22"',
    'Large: 33"x59"',
    'X-Large: 42"x72"',
    'Small: 14"x24"',
    'X-Small: 8"x14"'
];
var LVTSize5x7 = [
    'XX-Large',
    'XX-Large-Multi',
    'X-Large',
    'Large: 13.6"x19"',
    'Medium: 6.9"x9.25"',
    'Medium-Multi: 5.56"x7.69"',
    'Small: 3.6"x5.125"',
    'X-Small: 2.85"x4"',
    'XX-Small: 1.8"x2.5"',
    'XXX-Small: 1.4"x2"',
    'XXXX-Small: 1"x1.5"'
];
var LVTSize5x9 = [
    'XX-Large',
    'XX-Large-Multi',
    'X-Large',
    'Large: 11.1"x19"',
    'Medium: 5.3"x9.25"',
    'Medium-Multi: 5.3"x9.25"',
    'Small: 3.6"x6.125"',
    'X-Small: 2.29"x4"',
    'XX-Small: 1.74"x3"',
    'XXX-Small: 1.14"x2"',
    'XXXX-Small: 0.87"x1.5"'
];

var squareID = 0
var reflectSize5x7DimX = [22, 40, 42, 14, Infinity];
var reflectSize5x9DimX = [22, 33, 42, 14, Infinity];
var reflectSize5x7DimY = [33, 59, 59, 20, Infinity];
var reflectSize5x9DimY = [39.22, 59, 72, 24, Infinity];
var LVTSize5x7DimX = [Infinity, Infinity, Infinity, 13.6, 6.9, 5.56, 3.6, 2.85, 1.8, 1.4, 1];
var LVTSize5x9DimX = [Infinity, Infinity, Infinity, 11.1, 5.3, 5.3, 3.6, 2.29, 1.74, 1.14, 0.87];
var LVTSize5x7DimY = [Infinity, Infinity, Infinity, 19, 9.25, 7.69, 5.125, 4, 2.5, 2, 1.5];
var LVTSize5x9DimY = [Infinity, Infinity, Infinity, 19, 9.25, 9.25, 6.125, 4, 3, 2, 1.5];

/**
 * Chart object constructor
 */
function Chart() {

    // Select number of squares based on aspect ratio
    this.squares = options.squares;
    // Select substrate
    this.substrate = options.substrate;
    // Select contrast ratio
    this.contrast = options.contrast;
    // Select step chart, focus star, and color chart, defaults off for all
    this.stepchart = 0;
    this.focus = options.focus ? 0:1;
    this.color = options.color ? 1:0;
    // Set distortion to 0, not currently used
    this.distortion = 0;
    this.sizes      = null;
    this.xdim       = null;
    this.ydim       = null;
    this.lenschart  = null;
    this.pixdense   = null;
    this.chartid    = null;
    this.chartname  = null;
    this.charturl   = null;

    var code = '';
    if (this.substrate == 3) {
        code = 'SPLV';
    } else {
        code = 'SP';
    }
    for (var i = 0; i < chartTypes.length; i++) {
        if (chartTypes[i].code == code) {
            this.chartType = chartTypes[i];
        }
    }

    this.getSettings = getSettings;
    function getSettings() {
        if (this.substrate == 3) {
            this.settings = [this.squares, this.sizes, 0, this.contrast, this.stepchart, this.focus, this.color, this.distortion];
        } else {
            this.settings = [this.squares, this.sizes, this.substrate, this.contrast, this.stepchart, this.focus, this.color, this.distortion];
        }
        return this.settings;
    }

    // Gets the chart ID using the spconfig.js functions and the options for this chart
    //      If the substrate is LVT film, use the appropriate chart ID generator
    this.getChartId = getChartId;
    function getChartId() {
        this.getSettings();
        if (this.substrate == 3) {
            this.chartid = getChartNumber(this.settings, this.chartType);
        } else {
            this.chartid = getChartNumber(this.settings, this.chartType);
        }
    }

    // Gets the chart name using spconfig.js functions and the options for this chart
    //      If the substrate is LVT film, use the appropriate name generator
    this.getName = getName;
    function getName() {
        this.getSettings();
        if (this.substrate == 3) {
            this.chartname = getChartName(this.settings, this.chartType);
        } else {
            this.chartname = getChartName(this.settings, this.chartType);
        }
    }

    // Gets the lens-chart distance for this chart
    //      Original equation: H / |(2 * tan( VFoV/2 ))|
    //      Where H is the height of the chart and VFoV is the vertical field of view
    this.getLensChart = getLensChart;
    function getLensChart() {
        var denominator = Math.abs( 2 * Math.tan( metrics.vfov * Math.PI/360 ) );
        this.lenschart = round(this.xdim/denominator);
    }

    /**
     * Return the vertical pixel density in units of pixels per inch for MTF50, MTF70, and MTF90
     * @return {Array} Array of vertical pixel densities in pixels per inch in form [MTF50, MTF70, MTF90]
     */
    this.getPixDense = function () {
        var mtf = substrateMTF[substrateList[this.substrate]];
        var mtf50 = mtf[0]*this.xdim*25.4*2*1;
        var mtf70 = mtf[1]*this.xdim*25.4*2*1;
        var mtf90 = mtf[2]*this.xdim*25.4*2*1;
        mtf50 *= (mtf50*metrics.aspectratio)/1000000;
        mtf70 *= (mtf70*metrics.aspectratio)/1000000;
        mtf90 *= (mtf90*metrics.aspectratio)/1000000;

        this.pixdense = [round(mtf50), round(mtf70), round(mtf90)];
        return this.pixdense;
    };

    // Returns notes for the chart based on the options. Currently only relates to backlit charts and Multicharts
    this.getNotes = getNotes;
    function getNotes() {
        var note = '';
        if (this.substrate > 1 && !options.lightbox) { note += 'This chart must be backlit. We recommend using a lightbox. </br>';}
        if (this.substrate == 3 && this.sizes == 5) { note += 'This is a multi-size chart. It has 5 different sized of charts on one sheet of film that can be used. </br>';}
        if (note !== '') {note = 'Note: '+ note;}
        return note;
    }

    this.getURL=getURL;
    function getURL() {
        this.charturl = 'http://store.imatest.com/';

        switch (this.chartid) {

            case 'SP82188': this.charturl += 'extra-large-sfrplus-chart-for-high-megapixel-cameras.html';
                            break;
            case 'SP65792': this.charturl += 'sp65792.html';
                            break;
            case 'SP66688': this.charturl += 'sfr-plus-standard-b-w-test-chart.html';
                            break;
            case 'SPLV155912': this.charturl += 'splv155912.html';
                            break;
            case 'SPLV024840': this.charturl += 'splv024840.html';
                            break;
            case 'SPLV155916': this.charturl += 'splv155916.html';
                            break;
            case 'SPLV024844': this.charturl += 'splv024844.html';
                            break;
            case 'SPLV155904': this.charturl += 'splv155904.html';
                            break;
            case 'SPLV024832': this.charturl += 'splv024832.html';
                            break;
            default:        if (this.substrate < 2) {
                                switch (this.contrast) {
                                    case 0: this.charturl += 'test-charts.html';
                                            break;
                                    case 1: this.charturl += 'sfrplus-chart-inkjet-on-paper.html';
                                            break;
                                    case 2: this.charturl += 'sfrplus-chart-inkjet.html';
                                            break;
                                    case 3: this.charturl += 'test-charts.html';
                                            break;
                                    default:
                                            break;
                                }
                            } else if (this.substrate == 2) {
                                this.charturl += 'test-charts.html';
                            } else if (this.substrate == 3) {
                                if (this.sizes == 3) {
                                    this.charturl += 'sfrplus-large-lvt.html';
                                } else {
                                    this.charturl += 'sfrplus-test-chart-on-high-precision-lvt-film.html';
                                }
                            } else {
                                this.charturl += 'test-charts.html';
                            }
                            break;
        }
    return this.charturl;
    }
}

/**
* Displays and error in the specified section
*
* @param section    String containing the section with the error
* @param message    Error message to be shown
*/
function error(section, message) {
    var errorBlock = $('#about_' + section);
    errorBlock.html(errorBlock.html() + message + "<br>");
}

/**
* Removes an error message from the specified section
*
* @param section    String containing the section with the error
*/
function clear(section) {
    $('#about_' + section).empty();
}

/**
* Clear functions reset values for their input sections and updates
* calculated status for all values to reflect reset.
*/
function clearLightbox() {
    setPlaneMetric('boxheight',null, null);
    setPlaneMetric('boxwidth',null, null);
    metrics.boxwidth = Infinity;
    metrics.boxheight = Infinity;
    options.lightbox = false;
    updateAll();
}

function resetSection(section) {
    var current = '';
    $(section).find(':text').each(function() {
        current = $(this).attr('id');
        if (current == 'lenschart' || current == 'boxwidth' || current == 'boxheight') {
            metrics[current] = Infinity;
            originalMetrics[current] = null;
        } else {
            metrics[current] = null;
        }
        if (current == 'lenschart_min' || current == 'planewidth' || current == 'planeheight') {
            originalMetrics[current] = null;
        }
        calculated[current] = false;
        $(this).val(null);
        $(this).removeClass('set');
        $(this).removeClass('user');
    });
    $(section).find('[id$="reset"]').addClass('hidden');
    updateCharts();
    saveAll();
}

function resetAll() {
    resetSection($('#distance'));
    resetSection($('#lens'));
    resetSection($('#sensor'));
    resetSection($('#lightbox_input'));

//...Added...//
//...    $("#equipment_s").children('[type=checkbox]').each(function() {
//...        $(this).prop('checked',false);
//...        if ( options[$(this).val()] ) {
//...            updateOptions( $(this).val() );
//...        }
//...    });
//...End Added...//
    $("#test_items").children('[type=checkbox]').each(function() {
        $(this).prop('checked',false);
        if ( options[$(this).val()] ) {
            updateOptions( $(this).val() );
        }
    });
/*/...    $("[id='color']").prop('checked', true);
//...    updateOptions('color');
//... ADDED*/
//    $("[id='sharpness']").prop('checked', true);
//    updateOptions('sharpness');
/*/... END ADDED*/

    $("#lighting").children('[type=checkbox]').each(function() {
        $(this).prop('checked',true);
        if ( !options[$(this).val()] ) {
            updateOptions( $(this).val() );
        }
    });

    $('#41').prop('checked',true);
    options.contrast = 2;

    saveAll();
}

/*/...function buildJSON() {
//...    output  = '{';
//...    output += '"metrics":{';
//...    output += '"dfov":'             + String(metrics.dfov)                  + ',';
//...    output += '"vfov":'             + String(metrics.vfov)                  + ',';
//...    output += '"hfov":'             + String(metrics.hfov)                  + ',';
//...    output += '"pixelwidth":'       + String(metrics.pixelwidth)            + ',';
//...    output += '"pixelheight":'      + String(metrics.pixelheight)           + ',';
//...    output += '"megapixels":'       + String(metrics.megapixels)            + ',';
//...    output += '"aspectratio":'      + String(metrics.aspectratio)           + ',';
//...    output += '"lenschart":'        + String(originalMetrics.lenschart)     + ',';
//...    output += '"lenschart_min":'    + String(originalMetrics.lenschart_min) + ',';
//...    output += '"planewidth":'       + String(originalMetrics.planewidth)    + ',';
//...    output += '"planeheight":'      + String(originalMetrics.planeheight)   + ',';
//...    output += '"boxwidth":'         + String(originalMetrics.boxwidth)      + ',';
//...    output += '"boxheight":'        + String(originalMetrics.boxheight);
//...    output += '},';
//...    output += '"units":{';
//...    output += '"chartUnit":"'       + String(chartUnit)    + '",';
//...    output += '"chartUnitMin":"'    + String(chartUnitMin) + '",';
//...    output += '"lightboxUnit":"'    + String(lightboxUnit) + '"';
//...    output += '},';
//...    output += '"calculated":{';
//...    output += '"dfov":'             + String(calculated.dfov)          + ',';
//...    output += '"vfov":'             + String(calculated.vfov)          + ',';
//...    output += '"hfov":'             + String(calculated.hfov)          + ',';
//...    output += '"pixelwidth":'       + String(calculated.pixelwidth)    + ',';
//...    output += '"pixelheight":'      + String(calculated.pixelheight)   + ',';
//...    output += '"megapixels":'       + String(calculated.megapixels)    + ',';
//...    output += '"aspectratio":'      + String(calculated.aspectratio)   + ',';
//...    output += '"lenschart":'        + String(calculated.lenschart)     + ',';
//...    output += '"lenschart_min":'    + String(calculated.lenschart_min) + ',';
//...    output += '"planewidth":'       + String(calculated.planewidth)    + ',';
//...    output += '"planeheight":'      + String(calculated.planeheight)   + ',';
//...    output += '"boxwidth":'         + String(calculated.boxwidth)      + ',';
//...    output += '"boxheight":'        + String(calculated.boxheight);
//...    output += '},';
//...    output += '"options":{';
//...    output += '"reflective":'           + String(options.reflective)        + ',';
//...    output += '"transmissive":'         + String(options.transmissive)      + ',';
//...    output += '"color":'                + String(options.color)             + ',';
//...    output += '"focus":'                + String(options.focus)             + ',';
//...    output += '"signal_processing":'    + String(options.signal_processing) + ',';
//...    output += '"lightbox":'             + String(options.lightbox)          + ',';
//...    output += '"contrast":'             + String(options.contrast)          + ',';
//...    output += '"advanced":'             + String($('#mode').prop('checked'));
//...    output += '}';
//...    output += '}';
//...    return output;
//...}
//... ADDED*/
function buildJSON() {
    output  = '{';
    output += '"metrics":{';
    output += '"dfov":'             + String(metrics.dfov)                  + ',';
    output += '"vfov":'             + String(metrics.vfov)                  + ',';
    output += '"hfov":'             + String(metrics.hfov)                  + ',';
    output += '"pixelwidth":'       + String(metrics.pixelwidth)            + ',';
    output += '"pixelheight":'      + String(metrics.pixelheight)           + ',';
    output += '"megapixels":'       + String(metrics.megapixels)            + ',';
    output += '"aspectratio":'      + String(metrics.aspectratio)           + ',';
    output += '"lenschart":'        + String(originalMetrics.lenschart)     + ',';
    output += '"lenschart_min":'    + String(originalMetrics.lenschart_min) + ',';
    output += '"planewidth":'       + String(originalMetrics.planewidth)    + ',';
    output += '"planeheight":'      + String(originalMetrics.planeheight)   + ',';
    output += '"boxwidth":'         + String(originalMetrics.boxwidth)      + ',';
    output += '"boxheight":'        + String(originalMetrics.boxheight);
    output += '},';
    output += '"units":{';
    output += '"chartUnit":"'       + String(chartUnit)    + '",';
    output += '"chartUnitMin":"'    + String(chartUnitMin) + '",';
    output += '"lightboxUnit":"'    + String(lightboxUnit) + '"';
    output += '},';
    output += '"calculated":{';
    output += '"dfov":'             + String(calculated.dfov)          + ',';
    output += '"vfov":'             + String(calculated.vfov)          + ',';
    output += '"hfov":'             + String(calculated.hfov)          + ',';
    output += '"pixelwidth":'       + String(calculated.pixelwidth)    + ',';
    output += '"pixelheight":'      + String(calculated.pixelheight)   + ',';
    output += '"megapixels":'       + String(calculated.megapixels)    + ',';
    output += '"aspectratio":'      + String(calculated.aspectratio)   + ',';
    output += '"lenschart":'        + String(calculated.lenschart)     + ',';
    output += '"lenschart_min":'    + String(calculated.lenschart_min) + ',';
    output += '"planewidth":'       + String(calculated.planewidth)    + ',';
    output += '"planeheight":'      + String(calculated.planeheight)   + ',';
    output += '"boxwidth":'         + String(calculated.boxwidth)      + ',';
    output += '"boxheight":'        + String(calculated.boxheight);
    output += '},';
    output += '"options":{';
    output += '"reflective":'              + String(options.reflective)           + ',';
    output += '"transmissive":'            + String(options.transmissive)         + ',';
//...    output += '"lighting_eqp":'            + String(options.lighting_eqp)         + ',';
//...    output += '"test_fixtures":'           + String(options.test_fixtures)        + ',';
    output += '"sharpness":'               + String(options.sharpness)            + ',';
    output += '"noise":'                   + String(options.noise)                + ',';
    output += '"dynamic_range":'           + String(options.dynamic_range)        + ',';
    output += '"color_accuracy":'          + String(options.color_accuracy)       + ',';
    output += '"distortion":'              + String(options.distortion)           + ',';
    output += '"uniformity":'              + String(options.uniformity)           + ',';
    output += '"blemishes":'               + String(options.blemishes)            + ',';
    output += '"iso_sensitivity":'         + String(options.iso_sensitivity)      + ',';
    output += '"chromatic_abberation":'    + String(options.chromatic_abberation) + ',';
    output += '"flare":'                   + String(options.flare)                + ',';
    output += '"color_moire":'             + String(options.color_moire)          + ',';
    output += '"artifacts":'               + String(options.artifacts)            + ',';
    output += '"compression":'             + String(options.compression)          + ',';
    output += '"dmax":'                    + String(options.dmax)                 + ',';
    output += '"color_gamut":'             + String(options.color_gamut)          + ',';
    output += '"texture_detail":'          + String(options.texture_detail)       + ',';
    output += '"near_infrared":'           + String(options.near_infrared)        + ','; 
/*/...    output += '"color":'                   + String(options.color)                + ',';
//...    output += '"focus":'                   + String(options.focus)                + ',';
//...    output += '"signal_processing":'       + String(options.signal_processing)    + ',';
//...    output += '"lightbox":'                + String(options.lightbox)             + ',';
//...    output += '"contrast":'                + String(options.contrast)             + ',';*/
    output += '"advanced":'                + String($('#mode').prop('checked'));
    output += '}';
    output += '}';
    return output;
}
/*/... END ADDED*/

//Builds form response via hidden text field in cf7 in wordpress

function buildForm() {
    //Initial parameters
    formOutput  = ' ';
    formOutput += 'Diagonal FOV: '                   + String(round(metrics.dfov))                  + '\n';
    formOutput += 'Vertical FOV: '                   + String(round(metrics.vfov))                  + '\n';
    formOutput += 'Horizontal FOV: '                 + String(round(metrics.hfov))                  + '\n';
    formOutput += 'Sensor Width (pixels): '          + String(metrics.pixelwidth)                   + '\n';
    formOutput += 'Sensor Height (pixels): '         + String(metrics.pixelheight)                  + '\n';
    formOutput += 'Sensor Size (megapixels): '       + String(round(metrics.megapixels))            + '\n';
    formOutput += 'Aspect Ratio: '                   + String(round(metrics.aspectratio))           + '\n';
    formOutput += 'Ideal Lens to Chart Distance: '   + String(originalMetrics.lenschart)    +' '+String(chartUnit)   + '\n';
    formOutput += 'Min Lens to Chart Distance: '     + String(originalMetrics.lenschart_min)+' '+String(chartUnitMin)+ '\n';
//    formOutput += 'Plane Width: '                    + String(round(metrics.planewidth))    +' '+String(chartUnit)   + '\n';
    formOutput += 'Plane Width: '                    + String(round(convertDistance(metrics.planewidth, 'm')))    +' '+String(chartUnit)   + '\n';
//    formOutput += 'Plane Height: '                   + String(round(metrics.planeheight))   +' '+String(chartUnit)   + '\n';
   formOutput += 'Plane Height: '                    + String(round(convertDistance(metrics.planeheight, 'm')))    +' '+String(chartUnit)   + '\n'; 
  //Light source options
    formOutput += '\nLight Source: \n'  
    if (options.reflective == true) {
        formOutput += 'reflective'                   + '\n';
    }
    if (options.transmissive == true) {
        formOutput += 'transmissive'                 + '\n';
    }

/*/... ADDED*/
    //Equipment options
//...    formOutput += '\nEquipment: \n'  
//...    if (options.lighting_eqp == true) {
//...        formOutput += 'lighting_eqp'                 + '\n';
//...    }
//...    if (options.test_fixtures == true) {
//...        formOutput += 'test_fixtures'                + '\n';
//...    }
/*/... END ADDED*/

/*/Begin taken out...*/
    //Contrast options
/*/...    formOutput += '\nContrast: \n' 
    switch (options.contrast) {
        case 0:
            formOutput += '4:1' + '\n';
            break;
        case 1:
            formOutput += '2:1 & 10:1' + '\n';
            break;
        case 2:
            formOutput += '4:1' + '\n';
            break;
    }   

    //Square Dimensions
    formOutput += '\nSquare Dimensions:\n'
    if (squareID == 57) {
        formOutput += '5x7'                        + '\n';
    }   
    if (squareID == 59) {
        formOutput += '5x9'                        + '\n';
    }...*/
/*/end taken out...*/   
/*//...    //Testing options
//...    formOutput += '\nTesting Options: \n'    
//...    if (options.color == true) {
//...        formOutput += 'color'                        + '\n';
//...    }   
//...    if (options.signal_processing == true) {
//...        formOutput += 'Signal Processing'            + '\n';
//...    }   
//...    if (options.lightbox == true) {
//...        formOutput += 'lightbox'                     + '\n';
//...        formOutput += 'Box Width: '                  + String(metrics.boxwidth)    + ' ' + String(lightboxUnit)  + '\n';
//...        formOutput += 'Box Height: '                 + String(metrics.boxheight)   + ' ' + String(lightboxUnit)  + '\n';
//...    }  
//...    if (options.focus == true) {
//...        formOutput += 'focus'                        + '\n';
//...    }    
//... ADDED*/
    //Testing options
    formOutput += '\nImage Quality Factors: \n'
    if (options.sharpness == true) {
        formOutput += 'sharpness'                    + '\n';
    }    
    if (options.noise == true) {
        formOutput += 'noise'                        + '\n';
    }    
    if (options.dynamic_range == true) {
        formOutput += 'dynamic_range'                + '\n';
    }    
    if (options.color_accuracy == true) {
        formOutput += 'color_accuracy'               + '\n';
    }    
    if (options.distortion == true) {
        formOutput += 'distortion'                   + '\n';
    }    
    if (options.uniformity == true) {
        formOutput += 'uniformity'                   + '\n';
    }    
    if (options.blemishes == true) {
        formOutput += 'blemishes'                    + '\n';
    }    
    if (options.iso_sensitivity == true) {
        formOutput += 'iso_sensitivity'              + '\n';
    }    
    if (options.chromatic_abberation == true) {
        formOutput += 'chromatic_abberation'         + '\n';
    }    
    if (options.flare == true) {
        formOutput += 'flare'                        + '\n';
    }    
    if (options.color_moire == true) {
        formOutput += 'color_moire'                  + '\n';
    }    
    if (options.artifacts == true) {
        formOutput += 'artifacts'                    + '\n';
    }    
    if (options.compression == true) {
        formOutput += 'compression'                  + '\n';
    }    
    if (options.dmax == true) {
        formOutput += 'dmax'                         + '\n';
    }    
    if (options.color_gamut == true) {
        formOutput += 'color_gamut'                  + '\n';
    }    
    if (options.texture_detail == true) {
        formOutput += 'texture_detail'               + '\n';
    }    
    if (options.near_infrared == true) {
        formOutput += 'near_infrared'                + '\n';
    }    
//    if (options.color == true) {
//        formOutput += 'color'                        + '\n';
//    }   
//    if (options.signal_processing == true) {
//        formOutput += 'Signal Processing'            + '\n';
//    }   
    if (options.lightbox == true) {
        formOutput += 'lightbox'                     + '\n';
        formOutput += 'Box Width: '                  + String(metrics.boxwidth)    + ' ' + String(lightboxUnit)  + '\n';
        formOutput += 'Box Height: '                 + String(metrics.boxheight)   + ' ' + String(lightboxUnit)  + '\n';
    }  
    if (options.focus == true) {
        formOutput += 'focus'                        + '\n';
    }
/*/... END ADDED*/

    document.getElementById("data1").value = formOutput;

    return formOutput;
}



function saveAll () {
    // Save all metrics to a cookie for 30 days
    setCookie('saved', 'true', cookieExp);
    current = buildJSON();
    //Doing this idk how to javascript
    currentForm = buildForm()
    setCookie('myBuild', current, cookieExp);
}

function loadCookies() {
    saved = getCookie('saved');
    if (saved == 'true') {
        myCookie = getCookie('myBuild');
        if (myCookie !== null) {
            try{
                myBuild = jQuery.parseJSON( getCookie('myBuild') );
            }
            catch(err) {
                setCookie('saved', 'false', cookieExp);
                setCookie('myBuild', '', cookieExp);
                return;
            }
            calculated.dfov          = myBuild.calculated.dfov;
            calculated.hfov          = myBuild.calculated.hfov;
            calculated.vfov          = myBuild.calculated.vfov;
            calculated.pixelwidth    = myBuild.calculated.pixelwidth;
            calculated.pixelheight   = myBuild.calculated.pixelheight;
            calculated.megapixels    = myBuild.calculated.megapixels;
            calculated.aspectratio   = myBuild.calculated.aspectratio;
            calculated.lenschart     = myBuild.calculated.lenschart;
            calculated.lenschart_min = myBuild.calculated.lenschart_min;
            calculated.planewidth    = myBuild.calculated.planewidth;
            calculated.planeheight   = myBuild.calculated.planeheight;
            calculated.boxwidth      = myBuild.calculated.boxwidth;
            calculated.boxheight     = myBuild.calculated.boxheight;

            var lenschart = parseFloat( myBuild.metrics.lenschart );
            var boxwidth = parseFloat( myBuild.metrics.boxwidth );
            var boxheight = parseFloat( myBuild.metrics.boxheight );

            setMetric('dfov', myBuild.metrics.dfov);
            setMetric('hfov', myBuild.metrics.hfov);
            setMetric('vfov', myBuild.metrics.vfov);
            setMetric('pixelwidth', myBuild.metrics.pixelwidth);
            setMetric('pixelheight', myBuild.metrics.pixelheight);
            setMetric('megapixels', myBuild.metrics.megapixels);
            setMetric('aspectratio', myBuild.metrics.aspectratio);
            setPlaneMetric('planewidth', myBuild.metrics.planewidth,chartUnit);
            setPlaneMetric('planeheight', myBuild.metrics.planeheight,chartUnit);
            setPlaneMetric('lenschart', isNaN(lenschart) ? Infinity:lenschart, myBuild.units.chartUnit);
            setPlaneMetric('lenschart_min',myBuild.metrics.lenschart_min, myBuild.units.chartUnitMin);
            setPlaneMetric('boxwidth', isNaN(boxwidth) ? Infinity:boxwidth, myBuild.units.lightboxUnit);
            setPlaneMetric('boxheight', isNaN(boxheight) ? Infinity:boxheight, myBuild.units.lightboxUnit);

/*/...            reflective = myBuild.options.reflective;
//...            transmissive = myBuild.options.transmissive;
//...            color_option = myBuild.options.color;
//...            focus_option = myBuild.options.focus;
//...            signal_processing = myBuild.options.signal_processing;
//...            lightbox = myBuild.options.lightbox;
//...            contrast = myBuild.options.contrast;
//...            squares = myBuild.options.squares;
//... ADDED*/
            reflective = myBuild.options.reflective;
            transmissive = myBuild.options.transmissive;
//...            lighting_eqp = myBuild.options.lighting_eqp;
//...            test_fixtures = myBuild.options.test_fixtures;
            sharpness = myBuild.options.sharpness;
            noise = myBuild.options.noise;
            dynamic_range = myBuild.options.dynamic_range;
            color_accuracy = myBuild.options.color_accuracy;
            distortion = myBuild.options.distortion;
            uniformity = myBuild.options.uniformity;
            blemishes = myBuild.options.blemishes;
            iso_sensitivity = myBuild.options.iso_sensitivity;
            chromatic_abberation = myBuild.options.chromatic_abberation;
            flare = myBuild.options.flare;
            color_moire = myBuild.options.color_moire;
            artifacts = myBuild.options.artifacts;
            compression = myBuild.options.compression;
            dmax = myBuild.options.dmax;
            color_gamut = myBuild.options.color_gamut;
            texture_detail = myBuild.options.texture_detail;
            near_infrared = myBuild.options.near_infrared;
//            color_option = myBuild.options.color;
//            focus_option = myBuild.options.focus;
//            signal_processing = myBuild.options.signal_processing;
//            lightbox = myBuild.options.lightbox;
//            contrast = myBuild.options.contrast;
//            squares = myBuild.options.squares;
/*/... END ADDED*/

            var contrastOpt = ['101','102','41'];
            var squareOpt = [7,9];

/*/...            if (options.reflective != reflective) {
//...                updateOptions('reflective');
//...                $('#reflective').prop('checked',reflective);
//...            }
//...            if (options.transmissive != transmissive) {
//...                updateOptions('transmissive');
//...                $('#transmissive').prop('checked',transmissive);
//...            }
//...            if (options.color != color_option) {
//...                updateOptions('color');
//...                $('#color').prop('checked',color_option);
//...            }
//...            /*if (options.focus != focus_option) {
//...                updateOptions('focus');
//...                $('#focus').prop('checked',focus_option);
//...            }*/
//...            if (options.signal_processing != signal_processing) {
//...                updateOptions('signal_processing');
//...                $('#signal_processing').prop('checked',signal_processing);
//...            }
//...            if (options.lightbox != lightbox) {
//...                updateOptions('lightbox');
//...                $('#lightbox').prop('checked',lightbox);
//...            }
//...            updateContrast(contrastOpt[contrast]);
//...            $('#'+contrastOpt[contrast]).prop('checked', true);
//...
//...            updateSquareDims(squareOpt[squares]);
//...            $('#5'+squareOpt[squares]).prop('checked', true);
//...
//...            $('#mode').prop('checked', myBuild.options.advanced);
//...            if (myBuild.options.advanced) {
//...                $('#distance').removeClass('hidden');
//...            } else {
//...                $('#distance').addClass('hidden');
//...            }
//... ADDED*/
            if (options.reflective != reflective) {
                updateOptions('reflective');
                $('#reflective').prop('checked',reflective);
            }
            if (options.transmissive != transmissive) {
                updateOptions('transmissive');
                $('#transmissive').prop('checked',transmissive);
            }
//...            if (options.lighting_eqp != lighting_eqp) {
//...                updateOptions('lighting_eqp');
//...                $('#lighting_eqp').prop('checked',lighting_eqp);
//...            }
//...            if (options.test_fixtures != test_fixtures) {
//...                updateOptions('test_fixtures');
//...                $('#test_fixtures').prop('checked',test_fixtures);
//...            }
            if (options.sharpness != sharpness) {
                updateOptions('sharpness');
                $('#sharpness').prop('checked',sharpness);
            }
            if (options.noise != noise) {
                updateOptions('noise');
                $('#noise').prop('checked',noise);
            }
            if (options.dynamic_range != dynamic_range) {
                updateOptions('dynamic_range');
                $('#dynamic_range').prop('checked',dynamic_range);
            }
            if (options.color_accuracy != color_accuracy) {
                updateOptions('color_accuracy');
                $('#color_accuracy').prop('checked',color_accuracy);
            }
            if (options.distortion != distortion) {
                updateOptions('distortion');
                $('#distortion').prop('checked',distortion);
            }
            if (options.uniformity != uniformity) {
                updateOptions('uniformity');
                $('#uniformity').prop('checked',uniformity);
            }
            if (options.blemishes != blemishes) {
                updateOptions('blemishes');
                $('#blemishes').prop('checked',blemishes);
            }
            if (options.iso_sensitivity != iso_sensitivity) {
                updateOptions('iso_sensitivity');
                $('#iso_sensitivity').prop('checked',iso_sensitivity);
            }
            if (options.chromatic_abberation != chromatic_abberation) {
                updateOptions('chromatic_abberation');
                $('#chromatic_abberation').prop('checked',chromatic_abberation);
            }
            if (options.flare != flare) {
                updateOptions('flare');
                $('#flare').prop('checked',flare);
            }
            if (options.color_moire != color_moire) {
                updateOptions('color_moire');
                $('#color_moire').prop('checked',color_moire);
            }
            if (options.artifacts != artifacts) {
                updateOptions('artifacts');
                $('#artifacts').prop('checked',artifacts);
            }
            if (options.compression != compression) {
                updateOptions('compression');
                $('#compression').prop('checked',compression);
            }
            if (options.dmax != dmax) {
                updateOptions('dmax');
                $('#dmax').prop('checked',dmax);
            }
            if (options.color_gamut != color_gamut) {
                updateOptions('color_gamut');
                $('#color_gamut').prop('checked',color_gamut);
            }
            if (options.texture_detail != texture_detail) {
                updateOptions('texture_detail');
                $('#texture_detail').prop('checked',texture_detail);
            }
            if (options.near_infrared != near_infrared) {
                updateOptions('near_infrared');
                $('#near_infrared').prop('checked',near_infrared);
            }
//            if (options.color != color_option) {
//                updateOptions('color');
//                $('#color').prop('checked',color_option);
//            }
            /*if (options.focus != focus_option) {
                updateOptions('focus');
                $('#focus').prop('checked',focus_option);
            }*/
//            if (options.signal_processing != signal_processing) {
//                updateOptions('signal_processing');
//                $('#signal_processing').prop('checked',signal_processing);
//            }
//            if (options.lightbox != lightbox) {
//                updateOptions('lightbox');
//                $('#lightbox').prop('checked',lightbox);
//            }
//            updateContrast(contrastOpt[contrast]);
//            $('#'+contrastOpt[contrast]).prop('checked', true);
//
//            updateSquareDims(squareOpt[squares]);
//            $('#5'+squareOpt[squares]).prop('checked', true);

            $('#mode').prop('checked', myBuild.options.advanced);
            if (myBuild.options.advanced) {
                $('#distance').removeClass('hidden');
            } else {
                $('#distance').addClass('hidden');
            }
/*/... END ADDED*/

            updateAll();
            updateCharts();
        }
    }
}

/**
* Sets the given metric with the given value and sets calcuated and
* status
*
* @param metric             Metric to be set
* @param value              Value to be set
*/
function setMetric(metric, value) {
    var field = $('#'+metric);
    if (value !== null && value !== Infinity) {
        field.val(round(value));
        metrics    [metric] = value;
        if (!calculated[metric]) {
            field.addClass('user');
        } else {
            field.addClass('set');
        }
    } else {
        field.val(null);
        field.removeClass('set');
        field.removeClass('user');
        metrics    [metric] = null;
        calculated [metric] = false;
    }
}

/**
* Sets the given plane metric with the given value and sets calcuated and
* status.
* Different from setMetric because it parses the distance and maintains the
* user specified units throughout calculations.
*
* @param metric             Metric to be set
* @param value              Value to be set
*/
function setPlaneMetric(metric, value, unit) {
    var field = $('#'+metric);
    if (value !== null && value != Infinity) {
        field.val(round(value).toString()+unit);
        metrics [metric] = parseDistance(value,unit);
        if (!calculated[metric]) {
            field.addClass('user');
        } else {
            field.addClass('set');
        }
    } else {
        field.val(null);
        field.removeClass('set');
        field.removeClass('user');
        metrics    [metric] = value;
        calculated [metric] = false;
    }
}

/**
* Round the input value to two decimal places
*
* @param value      Value to be rounded
* @return           Value rounded to two decimal places
*/
function round(value) {
    value = Math.round(value * 100)/100;
    return value;
}
function square(x) { return x * x; }

/**
* Updates all input parameters in order and updates charts.
* Only updates lightbox parameters if the lightbox options is
* checked.
*/
function updateAll() {
    // Sensor
    clear('sensor');

    updateMaxLength();
    updateMaxWidth();
    updateMaxHeight();

    updatePixelWidth();
    updatePixelHeight();
    updateMegapixels();
    updateAspectRatio();


    //  lens
    clear('lens');
    fisheye_error=false;
    updateDFoV();
    updateHFoV();
    updateVFoV();

    if (fisheye_error) {
        error('lens','LENS ERROR: For Fisheye lenses please refer to <a href="http://www.imatest.com/solutions/ultra-wide/">Ultrawide solutions</a>');
    }

    // Test
    clear('test');
    updateLensChart();
    updateLensChartMin();
    updatePlaneWidth();
    updatePlaneHeight();

    if (options.lightbox) {
        updateBoxWidth();
        updateBoxHeight();
    }
    saveAll();
    updateCharts();
}

function send(queryURL)     //sends the get request to the REST server
{

    var xmlhttp = new XMLHttpRequest();


    xmlhttp.onreadystatechange = function() {       //  This recieves the response and calls the function to inetpert it when it arrives
        if (this.readyState == 4){

            // console.log("stuff");
            response = xmlhttp.responseText;

            parseResponse(response);

        }
    }

    xmlhttp.open("GET", queryURL, false);       //the false should mean that it makes the program wait for the response

    xmlhttp.setRequestHeader("Content-Type", "application/json");
    xmlhttp.send();

}

// function callbackFunction(xmlhttp) 
// {
    // alert("Response: " + xmlhttp.responseXML);
    // alert("Response: " + xmlhttp.responseText);
// }

/**
* Updates chart recommendations if the minimum required parameters are set.
* Also formats output with alternating classes to make reading easier.
*/
function updateCharts() {

    // console.log("chartUpdate");
    

    var enough = true;          // whether there is enough information to send the get request


    var distance = 0;           // local variables to hold calues converted to mm units

    var height = 0;
    var width = 0;

    var maxHeight = 0
    var maxWidth = 0

    var heightInPixels = 0      //  these aren't converted to mm, but they get local variables for consistency
    var widthInPixels = 0



    //check that all necesary attributes exist before sending query

    if( !(options.reflective || options.transmissive)){
        enough = false;
    }

    if(metrics.lenschart == Infinity){
        enough = false;
    }else{
        distance = convertDistance(metrics.lenschart, 'mm');
        // console.log("distance: " + distance);
    }

    if(metrics.planeheight == null){
        enough = false;
    }else{
        height = convertDistance(metrics.planeheight, 'mm');
        // console.log("Height: " + height);
    }

    if(metrics.planewidth == null){
        enough = false;
    }else{
        width = convertDistance(metrics.planewidth, 'mm');
        // console.log("Width: " + width);
    }

    if(metrics.maximumheight == null){
        enough = false;
    }else{
        maxHeight = convertDistance(metrics.maximumheight, 'mm');
        // console.log("Max height: " + maxHeight);
    }

    if(metrics.maximumwidth == null){
        enough = false;
    }else{
        maxWidth = convertDistance(metrics.maximumwidth, 'mm');
        // console.log("Max width: " + maxWidth);
    }

    if(metrics.pixelheight == null){
        enough = false;
    }else{
        heightInPixels = metrics.pixelheight;
        // console.log("Height in pixels: " + heightInPixels);
    }

    if(metrics.pixelwidth == null){
        enough = false;
    }else{
        widthInPixels = metrics.pixelwidth;
        // console.log("Width in pixels: " + widthInPixels);
    }

    // console.log("Enough Information: " + enough);

    var queryURLBase = "http://www.imatest.com:5000/findCharts?";      //  Where the chart finder will send the get request to
                                                                    //  the findCharts? section specifys which get method is called, everything before that is the address (if the port that the server is running on is changed it will need to be changed here to)

    if(enough){                             //  Build the REST query
        var queryURL = queryURLBase;

        queryURL = queryURL + "Reflective=" + (options.reflective & 1) + "&";
        queryURL = queryURL + "Transmissive=" + (options.transmissive & 1) + "&";

        queryURL = queryURL + "testDistance=" + distance + "&";

        queryURL = queryURL + "testHeight=" + height + "&";
        queryURL = queryURL + "testWidth=" + width + "&";

        queryURL = queryURL + "maxHeight=" + maxHeight + "&";
        queryURL = queryURL + "maxWidth=" + maxWidth + "&";

        queryURL = queryURL + "heightInPixels=" + heightInPixels + "&";
        queryURL = queryURL + "widthInPixels=" + widthInPixels + "&";

        var sh = (options.sharpness & 1);           //  convert to 1 / 0
        var no = (options.noise & 1);
        var dy = (options.dynamic_range & 1);
        var ca = (options.color_accuracy & 1);
        var di = (options.distortion & 1);
        var un = (options.uniformity & 1);
        var bl = (options.blemishes & 1);
        var is = (options.iso_sensitivity & 1);
        var ch = (options.chromatic_abberation & 1);
        var fl = (options.flare & 1);
        var co = (options.color_moire & 1);
        var ar = (options.artifacts & 1);
        var cm = (options.compression & 1);
        var dm = (options.dmax & 1);
        var cg = (options.color_gamut & 1);
        var te = (options.texture_detail & 1);
        var ne = (options.near_infrared & 1);

        var s = sh + no + dy + ca + di + un + bl + is + ch + fl + co + ar + cm + dm + cg + te + ne;     

        if(s==0){       // check if none of the options are selected
            queryURL = queryURL + "weightings=1,%201,%201,%201,%201,%201,%201,%201,%201,%201,%201,%201,%201,%201,%201,%201,%201";       //  if so act as if they are all selected
        }else{
            queryURL = queryURL + "weightings=" + sh + ",%20" + no + ",%20" + dy + ",%20" + ca + ",%20" + di + ",%20" + un + ",%20" + bl + ",%20" + is + ",%20" + ch + ",%20" + fl + ",%20" + co + ",%20" + ar + ",%20" + cm + ",%20" + dm + ",%20" + cg + ",%20" + te + ",%20" + ne;
        }

        // console.log(queryURL);

        send(queryURL);
        
    }//else{

        // "http://127.0.0.1:5000/findCharts?Reflective=1&Transmissive=1&testDistance=800.000432&testHeight=600.014953459328&testWidth=1080.0269162267903&maxHeight=1000.00054&maxWidth=2000.00108&heightInPixels=2500&widthInPixels=4500&weightings=1,%201,%201,%201,%201,%201,%201,%201,%201,%201,%201,%201,%201,%201,%201,%201,%201"

        // This was a default URL used for testing
        // send("http://127.0.0.1:5000/findCharts?Reflective=1&Transmissive=1&testDistance=800.000432&testHeight=1000.014953459328&testWidth=1800.0269162267903&maxHeight=1000.00054&maxWidth=2000.00108&heightInPixels=2500&widthInPixels=4500&weightings=1,%201,%201,%201,%201,%201,%201,%201,%201,%201,%201,%201,%201,%201,%201,%201,%201");
    // }

    if ( checkStatus() ) {
        // displayChart();
        // var i = 1;
  //    $("tr:even").each(function() {
  //        $(this).addClass( (i < 0) ? 'even':'odd');
  //        i *= -1;
  //    });
  //    i = -1;
  //    $("tr:odd").each(function() {
  //        $(this).addClass( (i < 0) ? 'even':'odd');
  //        i *= -1;
  //    });
  //    $("tr:first").removeClass('odd');
        saveAll();                                                          //cookie saving
    }
}

function parseResponse(response){

    // console.log("response: " + response);
    // console.log(typeof response);

    response = JSON.parse(response);
    // console.log("response: " + response);
    // console.log(typeof response);

    $('#chart_list').empty();

    if('found' in response){
        // console.log(data.found)
        // console.log(typeof data.found)
        charts = response.found;
        num = charts.length;
        console.log(num + " charts found")
        $('#about_chart > p:nth-child(2)').addClass('hidden');

        if(num > 0){
            // $('#about_chart > p:nth-child(2)').addClass('hidden');
            $('#about_chart > p:nth-child(1)').addClass('hidden');
            displayCharts2(charts);
        }else{
            $('#about_chart > p:nth-child(1)').removeClass('hidden');
            $('#chart_head').accordion('option', 'active', false);

        }
    }

}

function displayCharts2(charts){
    // console.log("displaying charts");

    // $('#about_chart > p:nth-child(2)').addClass('hidden');
    // $('#about_chart > p:nth-child(1)').removeClass('hidden');
    $(function() {
        $('#chart_list').accordion({ header: 'h3' });
        $('#chart_head').accordion({ header: 'h4' });
    });
    // $('#chart_head').removeClass('hidden');


    // $('#chart_list').empty();


    // $('#chart_list').append('<h3></h3>');

    $.each(charts, function(){
        // console.log("Chart: " + this['sku'])
        // console.log(this)
        $('#chart_list').append('<h3></h3>');

        var headTable = document.createElement('table');    //  Create the chart primary information table (this table contains the information displayed even when teh accordion is closed)

        var row1 = headTable.insertRow(0);
        var row2 = headTable.insertRow(1);

        var score = row1.insertCell(0);
        var minDistance = row1.insertCell(1);
        var maxDistance = row1.insertCell(2);
        var chartPhysicalHeight = row1.insertCell(3);
        var chartPhysicalWidth = row1.insertCell(4);
        

        var sku = row2.insertCell(0);
        var tm1 = row2.insertCell(1);
        var tm2 = row2.insertCell(2);
        var chart_height = row2.insertCell(3);
        var chart_width = row2.insertCell(4);

        $(score).append(this['score'].toPrecision(2)).addClass('chart_list_row score_label');
        $(minDistance).append(this['minDistance'].toPrecision(4) + ' mm').addClass('chart_list_row min_chart_distance_label');
        $(maxDistance).append(this['maxDistance'].toPrecision(4) + ' mm').addClass('chart_list_row max_chart_distance_label');
        $(chartPhysicalHeight).append(this['chartPhysicalHeight'].toPrecision(4) + ' mm').addClass('chart_list_row chart_physical_height_label');
        $(chartPhysicalWidth).append(this['chartPhysicalWidth'].toPrecision(4) + ' mm').addClass('chart_list_row chart_physical_width_label');

        $(sku).append(this['sku']).addClass('chart_list_row sku_label');
        $(chart_height).append(this['chartHeight'].toPrecision(4) + ' mm').addClass('chart_list_row chart_height_label');
        $(chart_width).append(this['chartWidth'].toPrecision(4) + ' mm').addClass('chart_list_row chart_width_label');

        $('#chart_list > h3:last-child').append(headTable);


        $('#chart_list').append('<div></div>');

        var table = document.createElement('table');

        row = table.insertRow(0);

        var scores = row.insertCell(0);
        // var id = row.insertCell(1);

        var shCell = row.insertCell(1);
        var noCell = row.insertCell(2);
        var dyCell = row.insertCell(3);
        var caCell = row.insertCell(4);
        var diCell = row.insertCell(5);

        var unCell = row.insertCell(6);
        var blCell = row.insertCell(7);
        var isCell = row.insertCell(8);
        var chCell = row.insertCell(9);

        var flCell = row.insertCell(10);
        var coCell = row.insertCell(11);
        var arCell = row.insertCell(12);
        var cmCell = row.insertCell(13);

        var dmCell = row.insertCell(14);
        var cgCell = row.insertCell(15);
        var teCell = row.insertCell(16);
        var neCell = row.insertCell(17);


        $(scores).append('Image Quality Factor Scores:').addClass('chart_list_details_row_title');
        // $(id).append(this['sku']).addClass('chartfinder_id');

        $(shCell).append(this['scores'][0]).addClass('chart_list_details_scores_row sh_score_label');       //  add all the image quality factor scores to the table
        $(noCell).append(this['scores'][1]).addClass('chart_list_details_scores_row no_score_label');
        $(dyCell).append(this['scores'][2]).addClass('chart_list_details_scores_row dy_score_label');
        $(caCell).append(this['scores'][3]).addClass('chart_list_details_scores_row ca_score_label');
        $(diCell).append(this['scores'][4]).addClass('chart_list_details_scores_row di_score_label');

        $(unCell).append(this['scores'][5]).addClass('chart_list_details_scores_row un_score_label');
        $(blCell).append(this['scores'][6]).addClass('chart_list_details_scores_row bl_score_label');
        $(isCell).append(this['scores'][7]).addClass('chart_list_details_scores_row is_score_label');
        $(chCell).append(this['scores'][8]).addClass('chart_list_details_scores_row ch_score_label');

        $(flCell).append(this['scores'][9]).addClass('chart_list_details_scores_row fl_score_label');
        $(coCell).append(this['scores'][10]).addClass('chart_list_details_scores_row co_score_label');
        $(arCell).append(this['scores'][11]).addClass('chart_list_details_scores_row ar_score_label');
        $(cmCell).append(this['scores'][12]).addClass('chart_list_details_scores_row cm_score_label');

        $(dmCell).append(this['scores'][13]).addClass('chart_list_details_scores_row dm_score_label');
        $(cgCell).append(this['scores'][14]).addClass('chart_list_details_scores_row cg_score_label');
        $(teCell).append(this['scores'][15]).addClass('chart_list_details_scores_row te_score_label');
        $(neCell).append(this['scores'][16]).addClass('chart_list_details_scores_row ne_score_label');


        var type = table.insertRow(-1);         //add the chart specifications (type, variant, substrate, size, etc) to the details table

        var typeTitle = type.insertCell(0);
        var typeName = type.insertCell(1);

        typeName.colSpan = 7;

        $(typeTitle).append('Chart type:').addClass('chart_list_details_row_title')
        $(typeName).append(this['typeName']).addClass('chart_list_details_names')


        //Possibly add if statement to not render this if it isn't relevent
        if(this['variantID'] > 0){
            var variant = table.insertRow(-1);

            var variantTitle = variant.insertCell(0);
            var variantName = variant.insertCell(1);

            variantName.colSpan = 7;

            $(variantTitle).append('Chart variant:').addClass('chart_list_details_row_title')
            $(variantName).append(this['variantName']).addClass('chart_list_details_names')
        }


        var substrate = table.insertRow(-1);

        var substrateTitle = substrate.insertCell(0);
        var substrateName = substrate.insertCell(1);

        substrateName.colSpan = 7;

        $(substrateTitle).append('Chart substrate:').addClass('chart_list_details_row_title')
        $(substrateName).append(this['substrateName']).addClass('chart_list_details_names')


        //Possibly add if statement to not render this if it isn't relevent
        if(this['gridSizeID'] > 0){
            var gridSize = table.insertRow(-1);

            var gridSizeTitle = gridSize.insertCell(0);
            var gridSizeName = gridSize.insertCell(1);

            gridSizeName.colSpan = 7;

            $(gridSizeTitle).append('Chart grid size:').addClass('chart_list_details_row_title')
            $(gridSizeName).append(this['gridSizeName']).addClass('chart_list_details_names')
        }


        var size = table.insertRow(-1);

        var sizeTitle = size.insertCell(0);
        var sizeName = size.insertCell(1);

        sizeName.colSpan = 7;

        $(sizeTitle).append('Chart size:').addClass('chart_list_details_row_title')
        $(sizeName).append(this['sizeName']).addClass('chart_list_details_names')


        //Possibly add if statement to not render this if it isn't relevent
        if(this['distortionID'] > 0){
            var distortion = table.insertRow(-1);

            var distortionTitle = distortion.insertCell(0);
            var distortionName = distortion.insertCell(1);

            distortionName.colSpan = 7;

            $(distortionTitle).append('Chart distortion:').addClass('chart_list_details_row_title')
            $(distortionName).append(this['distortionName']).addClass('chart_list_details_names')
        }


        var contrastRatio = table.insertRow(-1);

        var contrastRatioTitle = contrastRatio.insertCell(0);
        var contrastRatioName = contrastRatio.insertCell(1);

        contrastRatioName.colSpan = 7;

        $(contrastRatioTitle).append('Chart contrast ratio:').addClass('chart_list_details_row_title')
        $(contrastRatioName).append(this['contrastRatioName']).addClass('chart_list_details_names')


        if(this['attribute1'] > 0){
            var attribute1 = table.insertRow(-1);

            var attribute1Title = attribute1.insertCell(0);
            var attribute1Name = attribute1.insertCell(1);

            attribute1Name.colSpan = 7;

            $(attribute1Title).append(this['attribute1Name']).addClass('chart_list_details_row_title')
            $(attribute1Name).append(this['attribute1ValueName']).addClass('chart_list_details_names')
        }



        var header = table.createTHead();       //  Create the headder for each details table

        var headRow = header.insertRow(0);

        var headCell = headRow.insertCell(0);
        headCell.colSpan = 18;
        $(headCell).append('<b>Details:</b>');
        $(table).addClass('details');

        

        $('#chart_list > div:last-child').append(table)

    });

    $('td[class$=_label]').each(function() {                //update tooltips
        class_label = $(this).attr('class').split(/\s+/)[1];
        $(this).qtip({
            content: {
                text: tooltips[class_label].text,
                title: tooltips[class_label].title
            },
            position: {
                my: 'left top',
                at: 'right bottom',
                target: $(this),
                adjust: {
                    x: 10
                }
            },
            style: {
                classes: 'qtip-light qtip-shadow'
            },
            show: {
                solo: true,
                event: 'mouseenter'
            },
            hide: {
                fixed: true,
                event: 'unfocus mouseleave',
                delay: 750
            }
        });
    });


    $(function() {              //  update accordions

        // console.log("refreshing accordions")

        $('#chart_list').accordion('refresh');
        $('#chart_list').accordion('option', 'active', 0);
        $('#chart_list').accordion('option', 'heightStyle', 'content');

        $('#chart_head').accordion('refresh');
        $('#chart_head').accordion('option', 'active', 0);
        $('#chart_head').accordion('option', 'heightStyle', 'content');
        $('.chartfinder_add').click(function() {
            addCart( $('#cart ol'), $(this).siblings('table').find('td.chartfinder_id').text() );
        });
    });



    // console.log("displaying charts 2");

    /*

    $(function() {
        $('#chart_list').accordion({ header: 'h3' });
        $('#chart_head').accordion({ header: 'h4' });
    });
    $('#chart_list').empty();

    $('#chart_list').append('<h3></h3>');

    var headTable = document.createElement('table');
    var row = headTable.insertRow(0);

    var chartidCell = row.insertCell(0);

    $(chartidCell).append()

    // var chartidCell = row.insertCell(0);
    // var chartnameCell = row.insertCell(1);
    // var distanceCell = row.insertCell(2);

    // $(chartidCell).append(metrics.chartid).addClass("score").attr('id', 'chart_id');
    // $(chartnameCell).append();
    // $(distanceCell).append( round( convertDistance(metrics.lenschart, chartRecommendUnit) )+' '+chartRecommendUnit );


    $('#chart_list > h3:last-child').append(headTable);
    $('#chart_list').append('<div></div>');

    var table = document.createElement('table');

    // table = updateChart(table, this.settings, this.chartType);

    row = table.insertRow(0);
    var title = row.insertCell(0);
    var id = row.insertCell(1);
    $(title).append('Chart ID:');
    $(id).append(this.chartid).addClass('chartfinder_id');
    var header = table.createTHead();
    var headRow = header.insertRow(0);
    var headCell = headRow.insertCell(0);
    headCell.colSpan = 2;
    $(headCell).append('<b>Details</b>');
    $(table).addClass('details');

    $('#chart_list > div:last-child').append(table).append( $('<input type="button">').val('Add to List').addClass('chartfinder_add'),
                                                            $('<div>').addClass('details'),
                                                            $('<div>').addClass('details') );
    */
}

/**
* Returns true if pixelwidth, pixelheight, and dfov are set. Returns false otherwise.
*/
function checkStatus() {
    return ( metrics.pixelwidth !== null && metrics.pixelheight !== null && metrics.dfov !== null );
}

/**
* Calculates the FoV of the system if the correct parameters are set.
* Can calculate the diagonal FoV if the horizontal and vertical FoVs are entered,
* or calculates the horizontal and vertical if the diagonal is entered.
*/
function computeFoV() {
    if (metrics.hfov !== null && metrics.vfov !== null && !calculated.hfov && !calculated.vfov) {

        // Math:
        //  d^2 = x^2 + y^2
        //  x/y = tan(H/2)/tan(V/2)
        //  d = tan(D/2)
        //  tan(D/2)^2 = tan(H/2)^2 + tan(V/2)^2
        //  tan(D/2) = sqrt( tan(H/2)^2 + tan(V/2)^2 )
        //  D = 2 * atan( sqrt( tan(H/2)^2 + tan(V/2)^2 ) )

        temp = Math.sqrt(square(Math.tan(metrics.hfov*Math.PI/360)) + square(Math.tan(metrics.vfov*Math.PI/360)));

        calculated.dfov = true;
        setMetric('dfov', Math.atan(temp)*360/Math.PI);
    } else if ( metrics.dfov !== null && !calculated.dfov ) {
        clear('sensor');

        if(metrics.aspectratio !== null) {
            // Math:
            //  x/y = A (Aspect Ratio)
            //  x/y = tan(H/2)/tan(V/2)
            //  A * tan(V/2) = tan(H/2)
            //  tan(D/2)^2 = tan(H/2)^2 + tan(V/2)^2
            //  tan(D/2)^2 = A^2 * tan(V/2)^2 + tan(V/2)^2
            //  tan(D/2)^2 = (1 + A^2)tan(V/2)^2
            //  tan(D/2) = sqrt(1 + A^2)tan(V/2)
            //  tan(V/2) = tan(D/2)/sqrt(1 + A^2)
            //  V = 2 * atan( tan(D/2)/sqrt(1 + A^2) )
            //  H = 2 * atan( A * tan(V/2) )
            num = Math.tan(metrics.dfov*Math.PI/360);
            den = Math.sqrt(1+square(metrics.aspectratio));

            calculated.vfov = true;
            calculated.hfov = true;
            setMetric('vfov', 360 * Math.atan( num / den )/Math.PI);
            setMetric('hfov', 360 * Math.atan( (metrics.aspectratio * Math.tan(metrics.vfov*Math.PI/360)))/Math.PI );
        } else {
            error('sensor','We need to know the sensors aspect ratio to compute H/V FoV');
            return;
        }
    }
    $('#about_lens').html();
}
/**
* Currently not used.
*/
function computeDistortion() {
}
/**
* Computes the sensor data.
*/
function computeSensor() {
    computeMegapixels();
    computeAspectRatio();
    computePixelDims();
}
/**
* Calculates Megapixels by multiplying the pixel dimensions and dividing by one million
*/
function computeMegapixels() {
    if ( metrics.pixelwidth !== null && metrics.pixelheight !== null &&
         !calculated.pixelwidth && !calculated.pixelheight ) {
        calculated.megapixels = true;
        setMetric('megapixels', metrics.pixelwidth * metrics.pixelheight / 1000000);
    } else if ( (metrics.pixelwidth !== null || metrics.pixelheight !== null) &&
                (!calculated.pixelwidth || !calculated.pixelheight) &&
                metrics.aspectratio !== null && !calculated.aspectratio ) {
        calculated.megapixels = true;
        var MP;
        if (metrics.pixelwidth !== null) {MP = square(metrics.pixelwidth)/metrics.aspectratio;}
        if (metrics.pixelheight !== null) {MP = square(metrics.pixelheight)*metrics.aspectratio;}
        setMetric('megapixels', MP/1000000);
    }
}

function computePixelDims() {
    if ( metrics.aspectratio !== null && metrics.megapixels !== null &&
         !calculated.aspectratio && !calculated.megapixels ) {
        calculated.pixelwidth = true;
        calculated.pixelheight = true;
        setMetric('pixelwidth', Math.round(Math.sqrt(metrics.aspectratio*metrics.megapixels*1000000)));
        setMetric('pixelheight', Math.round(Math.sqrt(metrics.megapixels*1000000/metrics.aspectratio)));
    } else if ( (metrics.aspectratio !== null || metrics.megapixels !== null) &&
                (!calculated.aspectratio || !calculated.megapixels) ) {
        if ( metrics.pixelwidth !== null && !calculated.pixelwidth ) {
            calculated.pixelheight = true;
            var PH;
            if (metrics.aspectratio !== null) {PH = metrics.pixelwidth/metrics.aspectratio;}
            if (metrics.megapixels !== null) {PH = metrics.megapixels*1000000/metrics.pixelwidth;}
            setMetric('pixelheight', PH);
        } else if ( metrics.pixelheight !== null && !calculated.pixelheight ) {
            calculated.pixelwidth = true;
            var PW;
            if (metrics.aspectratio !== null) {PW = metrics.pixelheight*metrics.aspectratio;}
            if (metrics.megapixels !== null) {PW = metrics.megapixels*1000000/metrics.pixelheight;}
            setMetric('pixelwidth', PW);
        }
    }
}
/**
* Calculates the aspect ratio by dividing the pixel width by the height
*/
function computeAspectRatio() {
    if ( metrics.pixelwidth !== null && metrics.pixelheight !== null &&
         !calculated.pixelwidth && !calculated.pixelheight ) {
        calculated.aspectratio = true;
        setMetric('aspectratio', metrics.pixelwidth / metrics.pixelheight);
    } else if ( (metrics.pixelwidth !== null || metrics.pixelheight !== null) &&
                (!calculated.pixelwidth || !calculated.pixelheight) &&
                metrics.megapixels !== null && !calculated.megapixels ) {
        calculated.aspectratio = true;
        var AR;
        if (metrics.pixelwidth !== null) {AR = square(metrics.pixelwidth)/metrics.megapixels*1000000;}
        if (metrics.pixelheight !== null) {AR = metrics.megapixels*1000000/square(metrics.pixelheight);}
        setMetric('aspectratio', AR);
    }
}
/**
* Calculates the lens to chart distance using the imaging plane width or height, then
* calculates the remaining imaging plane using the found lens to chart distance.
*/
function computeLensChart() {
    var denominator;
    if ( metrics.planewidth !== null ) {
        denominator = Math.abs( 2 * Math.tan( ( Math.PI * metrics.hfov )/360 ) );
        originalMetrics.lenschart = originalMetrics.planewidth/denominator;
        calculated.lenschart = true;
        setPlaneMetric('lenschart', originalMetrics.lenschart, chartUnit);
        computeImagingPlane();

    } else if ( metrics.planeheight !== null ) {
        denominator = Math.abs( 2 * Math.tan( metrics.vfov * Math.PI/360 ) );
        originalMetrics.lenschart = originalMetrics.planeheight/denominator;
        calculated.lenschart = true;
        setPlaneMetric('lenschart', originalMetrics.lenschart, chartUnit);
        computeImagingPlane();
    }
}

/**
* Calculates the imaging plane dimensions using the horizontal and vertical fields of view.
*/
function computeImagingPlane() {
    if (metrics.lenschart === null) {
        error('test','Please enter a lens to chart distance');
    } else if (metrics.hfov === null || metrics.vfov === null) {
        error('lens','Please describe the lens\' field of view');
    } else {
        // tan(theta) = opp / adj
        // arctan(opp / adj)
        // degrees to radians
        calculated.planewidth = true;
        calculated.planeheight = true;
        setPlaneMetric('planewidth',  2 * originalMetrics.lenschart * Math.tan( metrics.hfov * Math.PI/360 ), chartUnit);
        setPlaneMetric('planeheight', 2 * originalMetrics.lenschart * Math.tan( metrics.vfov * Math.PI/360 ), chartUnit);
    }
}

function parseAspectRatio(input) {
    if (input !== null && input !== '') {
        input = String(input);
        var output;
        if ( input.indexOf(':') != -1 ) {
            var vals = input.split(':');
            output = vals[0]/vals[1];
        } else {
            output = parseFloat(input);
        }
        return output;
    } else { return null; }
}

function updateDFoV() {
    candidate_dfov = $('#dfov').val().match(/\d+\.?\d*/);
    if (candidate_dfov <= 0) {
        if (candidate_dfov !== null) {
            error('lens','Need a positive diagonal field of view');
        }
    } else if (isNaN(candidate_dfov)) {
        error('lens','Enter a numeric diagonal field of view');
    } else if (candidate_dfov >= 170) {
        fisheye_error = true;
    } else {
        setMetric('dfov', candidate_dfov);
        $('#lens_reset').removeClass('hidden');
    }
    computeFoV();
}

function updatePlaneWidth() {
    if (calculated.lenschart) {
        chartUnit = getUnit($('#planewidth').val());
        value = $('#planewidth').val().replace(chartUnit, '');
        candidate_planewidth = value.replace(' ','');
        if (isNaN(candidate_planewidth)) {
            error('test', 'Enter a imaging plane width');
        } else if (candidate_planewidth <= 0) {
            if (metrics.planewidth !== null) {
                error('test','Need a positive imaging plane width');
            }
        } else {
            clear('test');
            originalMetrics.planewidth = candidate_planewidth;
            setPlaneMetric('planewidth', candidate_planewidth, chartUnit);
            computeLensChart();
            $('#distance_reset').removeClass('hidden');
        }
    }
}
function updatePlaneHeight() {
    if (calculated.lenschart) {
        chartUnit = getUnit($('#planeheight').val());
        value = $('#planeheight').val().replace(chartUnit, '');
        candidate_planeheight = value.replace(' ','');
        if (isNaN(candidate_planeheight)) {
            error('test', 'Enter an imaging plane height');
        } else if (candidate_planeheight <= 0) {
            if (metrics.planeheight !== null) {
                error('test','Need an positive imaging plane height');
            }
        } else {
            clear('test');
            originalMetrics.planeheight = candidate_planeheight;
            setPlaneMetric('planeheight', candidate_planeheight, chartUnit);
            computeLensChart();
            $('#distance_reset').removeClass('hidden');
        }
    }
}
function updateBoxHeight() {
    lightboxUnit = getUnit($('#boxheight').val());
    value = $('#boxheight').val().replace(lightboxUnit, '');
    candidate_boxheight = value.replace(' ','');
    originalMetrics.boxheight = candidate_boxheight;
    if (isNaN(candidate_boxheight)) {
        error('lightbox', 'Enter a height for a lightbox');
    } else if (candidate_boxheight <= 0) {
        if (metrics.boxheight != Infinity) {
            error('lightbox','Need a positive height');
        }
    } else {
        clear('lightbox');
        setPlaneMetric('boxheight', candidate_boxheight, lightboxUnit);
    }
}
function updateBoxWidth() {
    lightboxUnit = getUnit($('#boxwidth').val());
    value = $('#boxwidth').val().replace(unit, '');
    candidate_boxwidth = value.replace(' ','');
    originalMetrics.boxwidth = candidate_boxwidth;
    if (isNaN(candidate_boxwidth)) {
        error('lightbox', 'Enter a width for a lightbox');
    } else if (candidate_boxwidth <= 0) {
        if (metrics.boxwidth != Infinity) {
            error('lightbox','Need a positive width');
        }
    } else {
        clear('lightbox');
        setPlaneMetric('boxwidth', candidate_boxwidth, lightboxUnit);
    }
}
function updateHFoV() {
    candidate_hfov = $('#hfov').val().match(/\d+\.?\d*/);
    if (isNaN(candidate_hfov)) {
        error('lens','Enter a numeric horizontal field of view');
    } else if (candidate_hfov <= 0) {
        if (metrics.hfov !== null) {
            error('lens','Need a positive horizontal field of view');
        }
    } else if (candidate_hfov >= 180) {
        fisheye_error = true;
    } else {
        setMetric('hfov', candidate_hfov);
        $('#lens_reset').removeClass('hidden');
    }
    computeFoV();
}
function updateVFoV() {
    candidate_vfov = $('#vfov').val().match(/\d+\.?\d*/);
    if (isNaN(candidate_vfov)) {
        error('lens','Enter a numeric vertical field of view');
    } else if (candidate_vfov <= 0) {
        if (metrics.vfov !== null) {
            error('lens','Need a positive vertical field of view');
        }
    } else if (candidate_vfov >= 180) {
        fisheye_error = true;
    } else {
        setMetric('vfov', candidate_vfov);
        $('#lens_reset').removeClass('hidden');
    }
    computeFoV();
}
function updateMaxLength() {
    spaceUnit = getUnit($('#spacelength').val());
    value = $('#spacelength').val().replace(spaceUnit, '');
    if (value !== '' || value !== null && metrics.maximumlength == null) {
        candidate_maximumlength = value.replace(' ','');
        if (isNaN(candidate_maximumlength)) {
            error('test', 'Enter a numeric maximum length');
        } else if (candidate_maximumlength <= 0) {
            if (metrics.maximumlength !== null) {
                error('test','Need a positive maximum length');
            }
        } else {
            clear('test');
            originalMetrics.maximumlength = candidate_maximumlength;
            setPlaneMetric('maximumlength', candidate_maximumlength, spaceUnit);
            // $('#distance_reset').removeClass('hidden');
            // computeImagingPlane();
        }
    } else {
        error('test', 'Enter a numeric maximum length');
    }
}
function updateMaxWidth() {
    spaceUnit = getUnit($('#spacewidth').val());
    value = $('#spacewidth').val().replace(spaceUnit, '');
    if (value !== '' || value !== null && metrics.maximumwidth == null) {
        candidate_maximumwidth = value.replace(' ','');
        if (isNaN(candidate_maximumwidth)) {
            error('test', 'Enter a numeric lens to chart distance');
        } else if (candidate_maximumwidth <= 0) {
            if (metrics.maximumwidth !== null) {
                error('test','Need a positive lens to chart distance');
            }
        } else {
            clear('test');
            originalMetrics.maximumwidth = candidate_maximumwidth;
            setPlaneMetric('maximumwidth', candidate_maximumwidth, spaceUnit);
            // $('#distance_reset').removeClass('hidden');
            // computeImagingPlane();
        }
    } else {
        error('test', 'Enter a numeric lens to chart distance');
    }
}
function updateMaxHeight() {
    spaceUnit = getUnit($('#spaceheight').val());
    value = $('#spaceheight').val().replace(spaceUnit, '');
    if (value !== '' || value !== null && metrics.maximumheight == null) {
        candidate_maximumheight = value.replace(' ','');
        if (isNaN(candidate_maximumheight)) {
            error('test', 'Enter a numeric lens to chart distance');
        } else if (candidate_maximumheight <= 0) {
            if (metrics.maximumheight !== null) {
                error('test','Need a positive lens to chart distance');
            }
        } else {
            clear('test');
            originalMetrics.maximumheight = candidate_maximumheight;
            setPlaneMetric('maximumheight', candidate_maximumheight, spaceUnit);
            // $('#distance_reset').removeClass('hidden');
            // computeImagingPlane();
        }
    } else {
        error('test', 'Enter a numeric lens to chart distance');
    }
}
function updatePixelWidth() {
    candidate_pixelwidth = $('#pixelwidth').val();
    if (isNaN(candidate_pixelwidth)) {
        error('sensor','Enter a numeric pixel width');
    } else if (candidate_pixelwidth <= 0) {
        if (metrics.pixelwidth !== null) {
            error('sensor','Need a positive pixel width');
        }
    } else if (candidate_pixelwidth != Math.round(candidate_pixelwidth)) {
        error('sensor','need an integer pixel width');
    } else {
        clear('sensor');
        setMetric('pixelwidth', candidate_pixelwidth);
        computeSensor();
        $('#sensor_reset').removeClass('hidden');
    }
}
function updatePixelHeight() {
    candidate_pixelheight = $('#pixelheight').val();
    if (isNaN(candidate_pixelheight)) {
        error('sensor','Enter a numeric pixel height');
    } else if (candidate_pixelheight <= 0) {
        if (metrics.pixelheight !== null) {
            error('sensor','Need a positive pixel height');
        }
    } else if (candidate_pixelheight != Math.round(candidate_pixelheight)) {
        error('sensor','need an integer pixel height');
    } else {
        clear('sensor');
        setMetric('pixelheight', candidate_pixelheight);
        computeSensor();
        $('#sensor_reset').removeClass('hidden');
    }
}
function updateMegapixels () {
    candidate_megapixels = $('#megapixels').val();
    if (isNaN(candidate_megapixels)) {
        error('sensor','Enter a numeric aspect ratio');
    } else if (candidate_megapixels <= 0) {
        if (metrics.megapixels !== null) {
            error('sensor','Need a positive aspect ratio');
        }
    } else {
        clear('sensor');
        setMetric('megapixels', candidate_megapixels);
        computeSensor();
        $('#sensor_reset').removeClass('hidden');
    }
}
function updateAspectRatio() {
    if (calculated.aspectratio) {
        candidate_aspectratio = metrics.aspectratio;
    } else {
        candidate_aspectratio = parseAspectRatio( $('#aspectratio').val() );
    }
    if (candidate_aspectratio <= 0) {
        if (metrics.aspectratio !== null) {
            error('sensor','Need a positive aspect ratio');
        }
    } else if (isNaN(candidate_aspectratio)) {
        error('sensor','Enter a numeric aspect ratio');
    } else {
        clear('sensor');
        setMetric('aspectratio', candidate_aspectratio);
        computeSensor();
        if (candidate_aspectratio >= 1.5) {
            $('#59').prop('checked', true);
            options.squares = 1;
            squareID = 59;
        } else {
            $('#57').prop('checked', true);
            options.squares = 0;
            squareID = 57;
        }
        $('#sensor_reset').removeClass('hidden');
    }
}
function updateSquareDims(value) {
    if (value == 7) {
        options.squares = 0;
    } else if (value == 9) {
        options.squares = 1;
    }
}
function updateLensChart() {
    chartUnit = getUnit($('#lenschart').val());
    value = $('#lenschart').val().replace(chartUnit, '');
    if (value !== '' || value !== null && metrics.lenschart == Infinity) {
        candidate_lenschart = value.replace(' ','');
        if (isNaN(candidate_lenschart)) {
            error('test', 'Enter a numeric lens to chart distance');
        } else if (candidate_lenschart <= 0) {
            if (metrics.lenschart !== Infinity) {
                error('test','Need a positive lens to chart distance');
            }
        } else {
            clear('test');
            originalMetrics.lenschart = candidate_lenschart;
            setPlaneMetric('lenschart', candidate_lenschart, chartUnit);
            $('#distance_reset').removeClass('hidden');
            computeImagingPlane();
        }
    } else {
        error('test', 'Enter a numeric lens to chart distance');
    }
}
function updateLensChartMin() {
    chartUnitMin = getUnit($('#lenschart_min').val());
    value = $('#lenschart_min').val().replace(chartUnitMin, '');
    if (value !== '' || value !== null && metrics.lenschart_min === null) {
        candidate_lenschart_min = value.replace(' ','');
        if (isNaN(candidate_lenschart_min)) {
            error('test', 'Enter a numeric lens to chart distance');
        } else if (candidate_lenschart_min <= 0) {
            if (metrics.lenschart_min !== null) {
                error('test','Need a positive lens to chart distance');
            }
        } else {
            clear('test');
            originalMetrics.lenschart_min = candidate_lenschart_min;
            setPlaneMetric('lenschart_min', candidate_lenschart_min, chartUnitMin);
            $('#distance_reset').removeClass('hidden');
        }
    } else {
        error('test', 'Enter a numeric lens to chart distance');
    }
}
function updateContrast(value) {
    switch (value) {
        case '4': options.contrast = 2;
                  options.focus = false;
                  break;
        case '102': options.contrast = 1;
                    break;
        case '10': options.contrast = 0;
                   break;
        default:
            break;
    }
}
function updateOptions(value) {
    options[value] = !options[value];
    if (value == 'lightbox') {
        $("#lightbox_input").toggleClass('hidden');
        if (options.lightbox) {
            options.transmissive = true;
            $("#transmissive").prop('checked', true);
            options.reflective = false;
            $("#reflective").prop('checked', false);
        } else {
            clearLightbox();
        }
    } else if (value == 'color' && options.focus) {
        $('#focus').prop('checked', false);
        options.focus = false;
    } else if (value == 'focus') {
        if (options.contrast < 2) {
            if (options.color) {
                $('#color').prop('checked', false);
                options.color = false;
            }
        } else {
            options.focus = false;
        }
    } else if (value == 'signal_processing') {
        updateContrast('102');
        $('#102').prop('checked',true);
        $('#41').prop('disabled', !$('#41').is(':disabled'));
        $('#101').prop('disabled', !$('#101').is(':disabled'));
    }
}
function checkLighting() {
    if (!options.reflective && !options.transmissive) {
        $("#light_error").removeClass('hidden');
        return false;
    } else {
        $("#light_error").addClass('hidden');
        return true;
    }
}
function updateUnits(value) {
    chartRecommendUnit = value;
}
function updateCQIFilter(value) {
    cqiFilter = value;
}
//...Added...//
//...function makeEQuipments() {
//...    var i = 0;
//...    $.each(eQuipmentIds, function(){
//...        $("#equipment_s").append('<input type="checkbox" id="'+this+'" value="'+this+'"><label for="'+this+'">'+eQuipments[i]+'</label></br>');
//...        i++;
//...    });
//...}
//...End Added...//
function makeTestItems() {
    var i = 0;
    $.each(testItemIds, function(){
        $("#test_items").append('<input type="checkbox" id="'+this+'" value="'+this+'"><label for="'+this+'">'+testItems[i]+'</label></br>');
        i++;
    });
}


function recommendSelect() {
    // Go through each possible substrate
    for (var j = 0; j < 4; j++) {
        // If lightbox is checked, only continue for transmissive substrates. If lightbox is not checked
        // only continue if the substrate is not DisplayTrans.
        if ( (options.reflective && j < 2) || (options.transmissive && j > 1) ) {
            if ( (options.lightbox && j > 1) || (!options.lightbox && j != 2) ) {
                // If the diagonal FoV is less than 70, only continue for Semi-Gloss and transmissive substrates.
                // If the DFoV is greater than 70, only continue for Matte and transmissive substrates.
                if ( ( j === 0 && metrics.dfov >= 70 ) || ( j == 1 && metrics.dfov < 70 ) || j > 1) {
                    options.substrate = j;
                    // Check the aspect ratio and select the chart dimension arrays based on aspect ratio and
                    // substrate.
                    var yDimArray;
                    var xDimArray;
                    if (options.squares == 1) {
                        yDimArray = (j == 3) ? LVTSize5x9DimY:reflectSize5x9DimY;
                        xDimArray = (j == 3) ? LVTSize5x9DimX:reflectSize5x9DimX;
                    } else {
                        yDimArray = (j == 3) ? LVTSize5x7DimY:reflectSize5x7DimY;
                        xDimArray = (j == 3) ? LVTSize5x7DimX:reflectSize5x7DimX;
                    }
                    // Go through each possible size for the given substrate.
                    for (var i = 0; i <= xDimArray.length - 1; i++) {
                        // Create a new Chart with the current settings for the current size.
                        chart = new Chart();
                        // If the substrate is LVT film and the size is a Multichart size, record a Multichart for
                        // the official size.
                        chart.sizes = ( j == 3 && ( i == 5 || i > 6 ) ) ? 5:i;
                        chart.xdim = xDimArray[i];
                        chart.ydim = yDimArray[i];
                        // Ignore the first two inkjet sizes for DisplayTrans.
                        if ( i > 2 || j != 2) {
                            // Check that the current chart fits in the lightbox if lightbox dimensions are specified.
                            if (chart.xdim <= metrics.boxheight && chart.ydim <= metrics.boxwidth) {
                                chart.getLensChart();
                                // Make sure the chart fits in the specified lens to chart range.
                                if (chart.lenschart <= metrics.lenschart && chart.lenschart >= metrics.lenschart_min) {
                                    chart.getPixDense();
                                    // Check that the chart is not too low resolution for the sensor
                                    // if ( (chart.pixdense < 140 && j != 3) ||
                                    //   (chart.pixdense < 420 && j == 3 && !options['color']) ||
                                    //   (chart.pixdense < 560 && j == 3 && options['color']) ) {
                                        // Ignore any non-existant chart sizes
                                        if (chart.lenschart != Infinity) {
                                            charts.push(chart);
                                        }
                                    // }
                                }
                            }
                        }
                    }
                }
            }
        }
    }
}

function displayChart() {
    var lastChartId = '';
    var chartQC = '';
    var lastLensChart = 0;
    // Hide the "Need more information..." message and remove all previous charts.
    $('#about_chart > p:first').addClass('hidden');
    $(function() {
        $('#chart_list').accordion({ header: 'h3' });
        $('#chart_head').accordion({ header: 'h4' });
    });
    $('#chart_list').empty();
    // Empty  and repopulate the chart array
    charts = [];
    recommendSelect();
    // Check that at least one chart met specifications. If not, display message directing to charts@iamtest.com
    if (charts.length !== 0) {
        // Hide sorry message
        $('#sorry').addClass('hidden');
        // Sort charts by lens to chart distance
        charts.sort(function(a,b) { return a.lenschart - b.lenschart; });
        $.each(charts, function(){
            // this.getSettings();
            this.getChartId();
            // Don't allow duplicate charts at duplicate distances.
            if (this.chartid != lastChartId || this.lenschart != lastLensChart) {
                lastChartId = this.chartid;
                lastLensChart = this.lenschart;
                this.getName();
                this.getURL();
                this.getPixDense();
                if (metrics.megapixels < this.pixdense[2]) {
                    chartQC = 'cqi90';
                } else if (metrics.megapixels < this.pixdense[1]) {
                    chartQC = 'cqi70';
                } else if (metrics.megapixels < this.pixdense[0]) {
                    chartQC = 'cqi50';
                } else {
                    chartQC = 'bad';
                }
                // Display chart
                if (chartQC != 'bad' && ((chartQC == cqiFilter) || cqiFilter == 'none')) {
                    $('#chart_list').append('<h3></h3>');
                    var headTable = document.createElement('table');
                    var row = headTable.insertRow(0);
                    var chartidCell = row.insertCell(0);
                    var chartnameCell = row.insertCell(1);
                    var distanceCell = row.insertCell(2);
                    $(chartidCell).append(this.chartid).addClass(chartQC).attr('id', 'chart_id');
                    $(chartnameCell).append(this.chartname).attr('id', 'chart_name');
                    $(distanceCell).append( round( convertDistance(this.lenschart, chartRecommendUnit) )+' '+chartRecommendUnit );
                    $('#chart_list > h3:last-child').append(headTable);
                    $('#chart_list').append('<div></div>');
                    var table = document.createElement('table');
                    table = updateChart(table, this.settings, this.chartType);
                    row = table.insertRow(0);
                    var title = row.insertCell(0);
                    var id = row.insertCell(1);
                    $(title).append('Chart ID:');
                    $(id).append(this.chartid).addClass('chartfinder_id');
                    var header = table.createTHead();
                    var headRow = header.insertRow(0);
                    var headCell = headRow.insertCell(0);
                    headCell.colSpan = 2;
                    $(headCell).append('<b>Details</b>');
                    $(table).addClass('details');
                    $('#chart_list > div:last-child').append(table).append( $('<input type="button">').val('Add to List').addClass('chartfinder_add'),
                                                                            $('<div>').addClass('details').html( '<a href="'+this.getURL()+'" target="_blank">Purchase</a>' ),
                                                                            $('<div>').addClass('details').html( this.getNotes() ) );
                }
            }
        });
        $(function() {
            $('#chart_list').accordion('refresh');
            $('#chart_list').accordion('option','heightStyle','content');
            $('#chart_head').accordion('refresh');
            $('#chart_head').accordion('option','heightStyle','content');
            $('.chartfinder_add').click(function() {
                addCart( $('#cart ol'), $(this).siblings('table').find('td.chartfinder_id').text() );
            });
        });
    } else {
        $('#sorry').removeClass('hidden');
    }
}

/**
 * Set cookie to given string with given expiration time in days
 * @param {String} c_name Name of cookie to set
 * @param {String} value  String form of data to store
 * @param {Number} exdays Number of days before cookie expires
 */
function setCookie(c_name,value,exdays) {
    var exdate=new Date();
    exdate.setDate(exdate.getDate() + exdays);
    var c_value=escape(value) + ((exdays === null) ? "" : "; expires="+exdate.toUTCString());
    document.cookie=c_name + "=" + c_value;
}

/**
 * Attempts to retrieve a cookie with name c_name from the client side
 * @param  {String} c_name Name of cookie to retrieve
 * @return {String}        String form of cookie data, if cookie not found, returns null
 */
function getCookie(c_name) {
    var c_value = document.cookie;
    var c_start = c_value.indexOf(" " + c_name + "=");
    if (c_start == -1) {
        c_start = c_value.indexOf(c_name + "=");
    }
    if (c_start == -1) {
        c_value = null;
    } else {
        c_start = c_value.indexOf("=", c_start) + 1;
        var c_end = c_value.indexOf(";", c_start);
        if (c_end == -1) {
            c_end = c_value.length;
        }
        c_value = unescape(c_value.substring(c_start,c_end));
    }
    return c_value;
}

