function init() {
    makeTestItems();
    $("[id='color']").prop('checked', true);
    updateOptions('color');
    loadCookies();

    $.each(chartTypes, function(n) {
        newOption = document.createElement('option');
        newOption.text = this.title;
        newOption.value = n;
        $('#chart_type').append(newOption);
    });

    updateChoices(0);
}

$(document).ready(function() {

    init();

    $("#chart_type").change(function() {
        updateChoices( $(this).val() );
    });

    $("#chart_id_button").change(function() {
        convertID( $(this).val() );
    });

    $("#generate").click(function() {
        generateID( $('#chart_type').val() );
    });

    $("#generate_custom").click(function() {
        generateCustomID( $('#chart_type').val() );
    });

    $("#mode").click(function() {
        $("#distance").toggleClass('hidden').attr('style', '');
        saveAll();
    });

    $("#test_items [type=checkbox]").click(function() {
        updateOptions( $(this).val() );
        updateCharts();
    });

    $("#lighting [type=checkbox]").click(function() {
        updateOptions( $(this).val() );
        if ( checkLighting() ) { updateCharts(); }
    });

    $("#contrast [type=radio]").click(function() {
        updateContrast( $(this).val() );
        updateCharts();
    });

    $("#square_dims [type=radio]").click(function() {
        updateSquareDims( $(this).val() );
        updateCharts();
    });

    $("[type=text]").change(function() {
        updateAll();
    });

    $("#units").change(function() {
        updateUnits( $(this).val() );
        updateCharts();
    });

    $("#cqi_filter").change(function() {
        updateCQIFilter( $(this).val() );
        updateCharts();
    });

    $("[id$='reset']").click(function() {
        resetSection( $(this).parent().parent() );
    });

    $("#reset_all").click(function() {
        resetAll();
    });

    $('.delete_cart').click(function() {
        $(this).parent().remove();
    });

    $('#generate_add').click(function() {
        generateID( $('#chart_type').val() );
        addCart( $('#cart ol'), $('#new_id').text() );
    });

    $('#translate_add').click(function() {
        addCart( $('#cart ol'), $('#chart_id_button').val() );
    });

    $(function() {
        $('#chart_list').accordion({ header: 'h3', collapsible: true, heightStyle:"content" });

        $('#chart_head').accordion({ header: 'h4', collapsible: true, heightStyle:"content", active: false });

        // $('#chart_head').accordion({ header: 'h4', collapsible: true, heightStyle:"content", active: true });

        // $('#chart_head').accordion({ header: 'h4', collapsible: false, heightStyle:"content", active: true });
        // $('#chart_head').accordion('option','collapsible', true);

        $('#tabs').tabs();

        $('#dialog_checkout').dialog({
            autoOpen: false,
            width: 500,
            modal: true,
            show: {
                effect: 'drop',
                duration: 400
            },
            hide: {
                effect: 'drop',
                duration: 400
            },
            buttons: {
                Ok: function() {
                    $(this).dialog('close');
                }
            }
        });

        $('#dialog_alert').dialog({
            autoOpen: false,
            width: 500,
            modal: true,
            dialogClass: 'ui-state-error',
            show: {
                effect: 'bounce',
                duration: 200
            },
            hide: {
                effect: 'explode',
                duration: 200
            },
            buttons: {
                "Close": function() {
                    $(this).dialog('close');
                }
            }
        });

        $('#checkout_button').click(function() {
            updateCart( $(this).parent().children('ol'), $('#dialog_checkout') );
            $('#dialog_checkout').dialog('open');
        });

        $('#cart ol').droppable({
            activeClass: 'ui-state-default',
            hoverClass: 'ui-state-hover',
            accept: ':not(.ui-sortable-helper),:not(.ui-dialog-buttons)',
            drop: function( event, ui ) {
                $(this).find( '.placeholder' ).remove();
                var newAdd = true;
                if (ui.draggable.children().length < 3) {
                    $(this).children().each(function(index, el) {
                        if ( $(el).text() == ui.draggable.text() ) {
                            $(el).find(':text').val( parseFloat( $(el).find(':text').val() )+1 );
                            newAdd = false;
                        }
                    });
                } else {
                    newAdd = false;
                }

                if (newAdd) {
                    var newItem = $('<li>').appendTo( this );
                    $('<span>').text( ui.draggable.text() ).addClass('cart_id').appendTo( newItem );
                    $('<input type="text">').attr('size','2').val('1').appendTo(
                        $('<span>').addClass('cart_quantity').appendTo( newItem ));
                    $('<input type="button">').val('X').addClass('delete_cart').appendTo( newItem );
                    $('.delete_cart').click(function() {
                        if ( $(this).parent().parent().children().length < 2 ) {
                            $('<li>').text('Place items here').addClass('placeholder').appendTo( $(this).parent().parent() );
                        }
                        $(this).parent().remove();
                    });
                }
            }
        }).sortable({
            items: 'li:not(.placeholder)',
            sort: function() {
                $(this).removeClass('ui-state-default');
            }
        });
    });

    $("[id$='fov']").change(function() {
        $("[id$='fov']").each(function() {
            value = $(this).val().match(/\d+\.?\d*/);
            if (value !== null && value !== '') {
                value += '\u00b0';
                $(this).val(value);
            }
        });
    });
});