/*
	Tooltip Generator
*/
var tooltips = {
	'pixelwidth_label': {
		title: 'Pixel Width',
		text: 'The number of pixels along the horizontal dimension of your sensor.'
	},
	'pixelheight_label': {
		title: 'Pixel Height',
		text: 'The number of pixels along the vertical dimension of your sensor.'
	},
	'mp_label': {
		title: 'Megapixels',
		text: 'The total resolution of your sensor in megapixels (millions of pixels).'
	},
	'aspectratio_label': {
		title: 'Aspect Ratio',
		text: 'The aspect ratio of your sensor. This can be entered in decimal form (1.5) or in ratio form (3:2). The expected order is width:height.'
	},
	'dfov_label': {
		title: 'Diagonal Field of View',
		text: 'The diagonal field of view of your imaging system in degrees (&deg;).'
	},
	'hfov_label': {
		title: 'Horizontal Field of View',
		text: 'The horizontal field of view of your imaging system in degrees (&deg;).'
	},
	'vfov_label': {
		title: 'Vertical Field of View',
		text: 'The vertical field of view of your imaging system in degrees (&deg;).'
	},
	'min_distance_label': {
		title: 'Minimum Focus Distance',
		text: 'The minimum focus distance of your system or the minimum lens to chart distance that your setup allows. This can be entered in any standard units </br> e.g. 12in, 1ft, 25cm, 0.1m, etc...'
	},
	'max_distance_label': {
		title: 'Maximum/Ideal Lens to Chart Distance',
		text: 'The maximum lens to chart distance of your overall setup <u>or</u> the ideal lens to chart distance for a given imaging plane. This can be entered in any standard units </br> e.g. 12in, 1ft, 25cm, 0.1m, etc... </br> <a href="http://www.imatest.com/docs/sfrplus_instructions/#distance" target="_blank">More Information</a>'
	},
	'planewidth_label': {
		title: 'Ideal Imaging Plane Width',
		text: 'The width of the imaging plane at a specific distance from the sensor/lens.'
	},
	'planeheight_label': {
		title: 'Ideal Imaging Plane Height',
		text: 'The height of the imaging plane at a specific distance from the sensor/lens.'
	},
	'spacelenth_label': {
		title: 'Maximum chart distance',
		text: 'The maximum possible distance between the camera and the test chart allowed by the test space'
	},
	'spacewidth_label': {
		title: 'Maximum chart width',
		text: 'The maximum width a chart could be and still fit in the lab'
	},
	'spaceheight_label': {
		title: 'Maximum chart height',
		text: 'The maximum height a chart could be and still fit in the lab'
	},
	'lightboxwidth_label': {
		title: 'Light Box Width',
		text: 'The maximum width of your light box.'
	},
	'lightboxheight_label': {
		title: 'Light Box Height',
		text: 'The maximum height of your light box.'
	},
	'reflective': {
		title: 'Reflective Lighting',
		text: 'Reflective, front illumination. Reflective lighting must be diffuse and the incident angle must be more than 45&deg; from the center optical axis. </br> <a href="http://www.imatest.com/docs/sfrplus_instructions/#lighting" target="_blank">More Information</a>'
	},
	'transmissive': {
		title: 'Transmissive Lighting',
		text: 'Transmissive, backlit illumination. Transmissive lighting should be diffuse and as uniform as possible, ideally from a light box.'
	},
	'mode': {
		title: 'Advanced Mode',
		text: 'Advanced mode provides additional options that allow you to specify the minimum focus distance and ideal lens-chart distance of your system.'
	},
	'41': {
		title: '4:1 Contrast Ratio',
		text: 'The 4:1 contrast ratio is recommended for most applications. It is the standard that will be upheld by the ISO in the upcoming ISO-12233 revision. </br> <a href="http://www.imatest.com/docs/sfrplus_instructions/#advantages" target="_blank">More Information</a>'
	},
	'101': {
		title: '10:1 Contrast Ratio',
		text: 'The 10:1 contrast ratio is recommended for cameras or situations where low contrast may result in charts that cannot be measured. </br> <a href="http://www.imatest.com/docs/sfrplus_instructions/#advantages" target="_blank">More Information</a>'
	},
	'102': {
		title: '10:1 & 2:1 Contrast Ratio',
		text: 'A mix of 10:1 and 2:1 contrast ratio slant edges are recommended when testing signal processing done on an image. It is not recommended for testing lens or sensor MTF. </br> <a href="http://www.imatest.com/docs/sfrplus_instructions/#advantages" target="_blank">More Information</a>'
	},
	'color': {
		title: 'Color Chart',
		text: 'A 20-patch color chart that can be used to determine basic color characteristics and behaviors of an imaging system. The reference files for these charts are included in Imatest. </br> <a href="http://www.imatest.com/docs/sfrplus_instructions3/#color" target="_blank">More Information</a>'
	},
	'focus': {
		title: 'Visual Focus Aid',
		text: 'A visual focus aid. On 4:1 contrast ratio charts the focus aid appears as smaller targets within the slant edge squares. They do not interefere in any way with the measurements made by Imatest. </br> On the 10:1/2:1 contrast ratio chart, the focus aid appears as a larger, high-contrast focus star that replaces the color chart. </br> <strong>Note: You cannot have the color chart and the focus star on the same chart!</strong>'
	},
	'signal_processing': {
		title: 'Signal Processing',
		text: 'Check this if you intend to primarily test the effects of signal processing on your images.'
	},
	'lightbox': {
		title: 'Light Box',
		text: 'Check this if you intend to backlight your test target using a light box.'
	},
	// 'chart_list_head_factors_label': {}
	'score_label': {
		title: 'Chart Score',
		text: 'Charts are scored on how well they meet your specifications.'
	},
	'min_chart_distance_label': {
		title: 'Minimum valid test distance',
		text: 'This is the smallest the distance between this chart and the camera can be without results becoming invalid due to chart resolution, or too much of the chart being outside the camera\'s field of view.'
	},
	'max_chart_distance_label': {
		title: 'Maximum valid test distance',
		text: 'This is the largest the distance between this chart and the camera can be without results becoming invalid due to the chart not filling enough of the camera\'s field of view.'
	},
	'chart_physical_height_label': {
		title: 'Chart Physical Height',
		text: 'The height of the physical chart (the height of the piece of medium on which the chart is printed.'
	},
	'chart_physical_width_label': {
		title: 'Chart Physical Width',
		text: 'The width of the physical chart (the width of the piece of medium on which the chart is printed.'
	},
	'sku_label': {
		title: 'Chart SKU',
		text: 'A chart\'s SKU identifies it in our magento store, and can be used either there or in the SKU lookup tool to uniquely identify a chart.'
	},
	'chart_height_label': {
		title: 'Chart Height',
		text: 'The height of the active area of the chart (the area that imatest software uses to analyze the camera).'
	},
	'chart_width_label': {
		title: 'Chart Width',
		text: 'The width of the active area of the chart (the area that imatest software uses to analyze the camera).'
	},
	'sh_score_label': {
		title: 'Sharpness',
		text: 'Sharpness detection score (from 0 to 1).'
	},
	'no_score_label': {
		title: 'Noise',
		text: 'Noise detection score (from 0 to 1).'
	},
	'dy_score_label': {
		title: 'Dynamic Range',
		text: 'Dynamic Range detection score (from 0 to 1).'
	},
	'ca_score_label': {
		title: 'Color Accuracy',
		text: 'Color Accuracy detection score (from 0 to 1).'
	},
	'di_score_label': {
		title: 'Distortion',
		text: 'Distortion detection score (from 0 to 1).'
	},
	'un_score_label': {
		title: 'Uniformity',
		text: 'Uniformity detection score (from 0 to 1).'
	},
	'bl_score_label': {
		title: 'Blemish',
		text: 'Blemish detection score (from 0 to 1).'
	},
	'is_score_label': {
		title: 'ISO Sensitivity',
		text: 'ISO Sensitivity score (from 0 to 1).'
	},
	'ch_score_label': {
		title: 'Chrmoatic Abberation',
		text: 'Chrmoatic Abberation detection score (from 0 to 1).'
	},
	'fl_score_label': {
		title: 'Flare',
		text: 'Flare detection score (from 0 to 1).'
	},
	'co_score_label': {
		title: 'Color Moire',
		text: 'Color Moire detection score (from 0 to 1).'
	},
	'ar_score_label': {
		title: 'Artifact',
		text: 'Artifact detection score (from 0 to 1).'
	},
	'cm_score_label': {
		title: 'Compression Losses',
		text: 'Compression Losses detection score (from 0 to 1).'
	},
	'dm_score_label': {
		title: 'Dmax',
		text: 'Dmax measurement score (from 0 to 1).'
	},
	'cg_score_label': {
		title: 'Color Gamut',
		text: 'Color Gamut measurement score (from 0 to 1).'
	},
	'te_score_label': {
		title: 'Texture',
		text: 'Texture measurement score (from 0 to 1).'
	},
	'ne_score_label': {
		title: 'Near Infrared',
		text: 'Near Infrared measurement score (from 0 to 1).'
	},
	'chart_optimum': {
		title: 'Optimum Lens to Chart Distance',
		text: 'This is the optimum lens to chart distance for your imaging system and a given chart. This distance fills the vertical field of view of your sensor with the chart where the bar-to-bar height of the chart is 90% of that vertical FoV. </br> <a href="http://www.imatest.com/docs/sfrplus_instructions/#photo" target="_blank">More Information</a>'
	},
	'cqi_filter': {
		title: 'Chart Quality Index',
		text: 'The Chart Quality Index (CQI) is a method to determine the adequacy of a chart for a given sensor. <br \\> CQI90 indicates this chart is good for measurements of MTF90 and lower. <br \\> CQI70 inidcates this chart is good for measurments of MT70 and lower, etc... </br> <a href="http://www.imatest.com/docs/chart-quality-index/" target="_blank">More Information</a>'
	}
}

$(document).ready(function() {

	$('[id$=_label]').each(function() {
		$(this).qtip({
			content: {
				text: tooltips[$(this).attr('id')].text,
				title: tooltips[$(this).attr('id')].title
			},
			position: {
				my: 'left top',
				at: 'right bottom',
				target: $(this).children('[type=text]'),
				adjust: {
					x: 10
				}
			},
			style: {
				classes: 'qtip-light qtip-shadow'
			},
			show: {
				solo: true,
				event: 'mouseenter'
			},
			hide: {
				fixed: true,
				event: 'unfocus mouseleave',
				delay: 750
			}
		});
	});

	$('label').each(function() {
		if ( $.inArray( $(this).attr('for'),Object.keys(tooltips) ) != -1 ) {
			$(this).qtip({
				content: {
					text: tooltips[$(this).attr('for')].text,
					title: tooltips[$(this).attr('for')].title
				},
				position: {
					my: 'left top',
					at: 'right bottom',
					adjust: {
						x: 10
					}
				},
				style: {
					classes: 'qtip-light qtip-shadow'
				},
				show: {
					solo: true,
					event: 'mouseenter'
				},
				hide: {
					fixed: true,
					event: 'unfocus mouseleave',
					delay: 750
				}
			});
		}
	});
/*
	$('#chart_optimum').qtip({
		content: {
			text: tooltips[$('#chart_optimum').attr('id')].text,
			title: tooltips[$('#chart_optimum').attr('id')].title
		},
		position: {
			my: 'bottom center',
			at: 'top center',
			adjust: {
				y: -10
			}
		},
		style: {
			classes: 'qtip-light qtip-shadow'
		},
		show: {
			solo: true,
			event: 'mouseenter'
		},
		hide: {
			fixed: true,
			event: 'unfocus mouseleave',
			delay: 750
		}
	});
	*/
});