function getChartNumber( settings, chart ) {

	var exceptCheck = false;
	var tempCheck;
	var sizeSuffix = '';

	if (chart.exceptions.length > 0) {
		$.each(chart.exceptions, function(n) {
			tempCheck = true;
			for (var i = 0; i < this.length; i++) {
				tempCheck = tempCheck & this[i].test(settings[i]);
			}
			exceptCheck = exceptCheck | tempCheck;
		});
	} else {
		exceptCheck = false;
	}

	var suffix = $('#custom_suffix').val();
	if ((settings[1]==7 && (chart.name == 'sfrplus' || chart.name == 'checkerboard')) || 
		(settings[1]==4 && chart.name == 'iso')  || 
		(settings[1]==11 && chart.name == 'lvt_sfrplus') || 
		(settings[3]==4 && chart.name == 'random') ||
		(settings[3]==4 && chart.name == 'spilled' ) || 
		(settings[1]==11 && chart.name == 'lvt_sfrplus')) {
		if (suffix == '') {
			alert ("enter a custom suffix");
			$('#custom_suffix').focus();
			$('#generatedSKU').hide();
			exceptCheck = true;
		} else {
			sizeSuffix = '-' + suffix;
		}
	}

	if (!exceptCheck) {
		var chartNumber = settings[0];
		for (var i = 1; i <= chart.options.length - 1; i++) {
			chartNumber = chartNumber << chart.options[i].bits;
			chartNumber += settings[i];
		}
		return chart.code+PadDigits(chartNumber,chart.padding)+sizeSuffix;
	} else {
		return -1;
	}
}

function getChartName( settings, chart ) {

	var name = chart.title+'-';
	var opt = '';

	for (var i = 0; i < settings.length; i++) {
		opt = chart.options[i].codes[ settings[i] ];
		if (opt.length > 0) {
			name += opt+'-';
		}
	}

	name = name.substr(0,name.length-1);
	return name;
}

function convertID( chartID ) {

	if (chartID.length > 0){
		var idCode = getPrefix( chartID );

		$.each(chartTypes, function() {
			if ( idCode.toLowerCase() == this.code.toLowerCase() ) {
				thisChart = this;
				return false;
			}
		});
		var settings = getChartValues( chartID, thisChart );
		var table = document.getElementById("convert_tool");
		table = updateChart( table, settings, thisChart );
	}
}

function getChartValues( chartID, chart ){
	var chartNum = parseFloat( chartID.slice(chart.code.length) );

	var chartValues = [];

	for (var i = chart.options.length - 1; i >= 1; i--) {
		chartValues.push( chartNum & (Math.pow(2,chart.options[i].bits)-1) );
		chartNum = chartNum >> chart.options[i].bits;
	}

	chartValues.push(chartNum);
	chartValues.reverse();

	return ( chartValues );
}

function PadDigits(n, totalDigits)
{
	n = n.toString();
	var pd = '';
	if (totalDigits > n.length)
	{
		for (i=0; i < (totalDigits-n.length); i++){
			pd += '0';
		}
	}
	return pd + n.toString();
}

function getPrefix( chartID ) {
	var c = NaN;
	var n = 0;
	while (isNaN(c) && n<100) {
		c = parseFloat(chartID.charAt(n));
		n++;
	}
	return chartID.substr(0,n-1);
}

function updateChoices( chartVal ) {

	var thisType = chartTypes[chartVal];
	var label = '';
	var insertText = '';
	var table = document.getElementById("generator_tool");
	while (table.rows.length > 3){
		table.deleteRow(1);
	}

	for (var i = 0; i < thisType.options.length; i++) {
		label = thisType.options[i].name.toLowerCase().replace(' ', '-');
		var row = table.insertRow(table.rows.length-2);
		var title = row.insertCell(0);
		var field = row.insertCell(1);

		title.innerHTML = '<label>'+thisType.options[i].name+':</label>';

		if (thisType.options[i].count > 1) {
			var menu = document.createElement("select");
			menu.id = label+'_opt';
			$.each(thisType.options[i].fieldnames, function(n) {
				if (thisType.options[i].codes[n] != 'NA') {
					newOpt = document.createElement("option");
					newOpt.text = this;
					newOpt.value = n;
					menu.add(newOpt);
				}
			});
			$(field).append(menu);
		} else {
			field.innerHTML = '<span id='+label+'_opt>'+thisType.options[i].fieldnames[0]+'</span>';
		}
	}
	$('[id$=_opt]').change(function() {
		updateImage();
	});

	// Set default values that aren't the 0 index of the options array.
    if (thisType.code == 'SP') {
        $('#'+thisType.options[0].name.toLowerCase().replace(' ', '-')+'_opt').val(1);
        $('#'+thisType.options[3].name.toLowerCase().replace(' ', '-')+'_opt').val(2);
        $('#'+thisType.options[5].name.toLowerCase().replace(' ', '-')+'_opt').val(1);
        $('#'+thisType.options[6].name.toLowerCase().replace(' ', '-')+'_opt').val(1);
    }
}

function updateChart( table, settings, chart ) {
	while (table.rows.length > 0) {
		table.deleteRow(0);
	}

	for (var i = 0; i < settings.length; i++) {
		var label = chart.options[i].name.toLowerCase();
		var name = chart.options[i].fieldnames[settings[i]];
		if (name === undefined) {
			while (table.rows.length > 0) {
				table.deleteRow(0);
			}
			alert("Not a valid chart ID!");
			return;
		}
		var row = table.insertRow(-1);
		var title = row.insertCell(0);
		var field = row.insertCell(1);

		$(title).append(chart.options[i].name+':');
		$(field).append(name);
	}

	row = table.insertRow(-1);
	$(row).append( $('<td>').attr('colspan', '2').append(function() {
		var fullText = '';
		for (var i = 0; i < settings.length; i++) {
			if (i < settings.length-1) {
				fullText += chart.options[i].name+':'+chart.options[i].fieldnames[settings[i]]+', ';
			} else {
				fullText += chart.options[i].name+':'+chart.options[i].fieldnames[settings[i]];
			}
		}
		return fullText;
	}));

	/*jsl:ignore*/
	return table;
	/*jsl:end*/
}

function updateImage( chart ) {



}
function generateCustomID( chartNumber)  {
	var suffix = $('#custom_suffix').val();
	if (suffix == '') {
		alert("please enter a custom suffix");
		$('#custom_suffix').focus();
	} else {

		$('#size_opt > option').each(function() {
			if (this.text == "Custom") {
				this.selected = true;
			}
		});

		generateID(chartNumber);	
	}
}

function reset_custom() {
	$('#custom_suffix').val('');
	$('#generatedSKU').hide();

}

function generateID( chartNumber ) {
	var settings = [];

	$('[id$=_opt]').each(function() {
		value = parseFloat( $(this).val() );
		if (isNaN(value)) {value = 0;}
		settings.push( value );
	});

	var newID = getChartNumber( settings, chartTypes[chartNumber] );
	if (newID == -1) {
		$('#dialog_alert').dialog('open');
	} else {
		$('#generatedSKU').show();
		$('#new_id').text(newID);
	}
}

function updateCart( cart, checkout ) {
	$(checkout).children('table').remove();

	var newTable = $('<table>').appendTo( checkout );
	var newRow = $('<tr>').appendTo( newTable );
	$('<th>').text('SKU').addClass('checkout_sku').appendTo( newRow );
	$('<th>').text('Quantity').addClass('checkout_quantity').appendTo( newRow );

	$(cart).children().each(function(index, el) {
		if ( $(el).children().length > 0 ) {
			newRow = $('<tr>').appendTo( newTable );
			$('<td>').text( $(el).children().first().text() ).appendTo( newRow );
			$('<td>').text( $(el).find(':text').val() ).appendTo( newRow );
		}
	});
}

function addCart( cart, sku ) {
	if (sku !== '') {
		$(cart).find( '.placeholder' ).remove();
		var newAdd = true;
		$(cart).children().each(function(index, el) {
			if ( $(el).text() == sku ) {
				$(el).find(':text').val( parseFloat( $(el).find(':text').val() )+1 );
				newAdd = false;
			}
		});
		if (newAdd) {
			var newItem = $('<li>').appendTo( cart );
			$('<span>').text( sku ).addClass('cart_id').appendTo( newItem );
			$('<input type="text">').attr('size','2').val('1').appendTo(
				$('<span>').addClass('cart_quantity').appendTo( newItem ) );
			$('<input type="button">').val('X').addClass('delete_cart').appendTo( newItem );
			$('.delete_cart').click(function() {
				if ( $(this).parent().parent().children().length < 2 ) {
					$('<li>').text('Place items here').addClass('placeholder').appendTo( $(this).parent().parent() );
				}
				$(this).parent().remove();
			});
		}
	}
}