function getUnit(input){
	input = input.replace(' ','');
	number = input.match(/\d+\.?\d*/);
	unit = input.replace(number, '');
	unit = (unit == null || unit == '')? 'in':unit;
	return(unit);
}

function parseDistance(input, unit) {
	// strip the spaces
	if (isFinite(input)) {input = input.toString()};
	input = input.replace(' ','');
	
	// extract the number
	number = input.match(/\d+\.?\d*/);
	if (number =='') {
		alert("Error - Not a number")
		return;
	}
	number = parseFloat(number);

	if (unit == '') {unit = getUnit(input)};

	if (unit=="\'" || unit == "ft" || unit == "feet") {
		scaling = 12;
	} else if (unit=="\"" || unit == "in" || unit == "inches" || unit == null) {
		scaling = 1;
	} else if (unit=='cm') {
		scaling = 0.393701;
	} else if (unit=='m') {
		scaling = 39.3701;
	} else if (unit == 'mm') {
		scaling = 0.0393701;
	} else {
		alert('Error: Unknown unit ' + unit);
		scaling = Infinity;
	}
	return(number * scaling);
}

function convertDistance(input, unitTo) {
	// strip the spaces
	if (isFinite(input)) {input = input.toString()};
	input = input.replace(' ','');
	
	// extract the number
	number = input.match(/\d+\.?\d*/);
	if (number =='') {
		alert("Error - Not a number")
		return;
	}
	number = parseDistance(parseFloat(number));

	if (unitTo == "\'" || unitTo == 'ft' || unitTo == 'feet') {
		return (number / 12);
	} else if (unitTo == '\"' || unitTo == 'in' || unitTo == 'inches') {
		return number;
	} else if (unitTo == 'yards') {
		return (number / 36);
	} else if (unitTo == 'cm') {
		return (number * 2.54);							//updated unit conversion ratios to follow NIST standard 
	} else if (unitTo == 'mm') {
		return (number * 25.4);
	} else if (unitTo == 'm') {
		return (number * 0.0254);
	} else {
		return(-1);
	}
}
