var products = ["Imatest Master", "Imatest IS", "Imatest IT/IT-P", "Imatest Studio"];
var prodShort = ['master','is','it','studio'];
/// NOTE: Do not change the values of prodShort, they are used in other places!
var currentVersion = '4.4.13';
var plat = navigator.platform;
var thankYouUrl = '/trial-download-thank-you';
var DOWNLOAD_FULL = 'Download Full Version';
var DOWNLOAD_BETA = 'Download Beta';
var DOWNLOAD_TRIAL = 'Download Trial';
var DOWNLOAD_UPGRADE = 'Download Upgrade';


function fadeIn(el, always)
{
	if (always || (!el.is(':visible') || el.css('visibility') == 'hidden')) {
		el.css('opacity', '0')
			.css('visibility', 'visible')
			.show()
			.animate({
				opacity: 1,

			}, 1000);
	}
}

function fadeOut(el, always) {
	if (always || (el.is(':visible') || el.css('visibility') == 'visible')) {
		el.css('opacity', '1')
			.animate({
				opacity: 0,

			},
				{
					complete: function (el) {
						$(this).css('visibility', 'hidden');
					},
					duration: 1000
				});
	}
}
$(document).ready(function () {
	var downloadPageType = 'full';

	if (typeof(window.downloadPageType) === 'undefined') {
		downloadPageType = 'trial';
	} else {
		downloadPageType = window.downloadPageType;
	}

	$('#lnkPreviousReleases').click(function (event) {

		$('#lnkPreviousReleases').hide();
		fadeIn($('#legacyReleases'), true);
	});

	$('#lnkHidePreviousReleases').click(function (event) {
		$('#legacyReleases').hide();
		fadeIn($('#lnkPreviousReleases')), true;

		$('input[name=version].currentVersion').click();

	});

	$('input:radio[name="product"]').click(function (event) {
		var thisProduct = $(this).attr('value');

		/// Toggle Product versions
		$('div[id$="_info"]').not('#' + thisProduct + '_info').hide();
		fadeIn($('#' + thisProduct + '_info'), true);

		if (thisProduct == 'gamut')
		{
			$('#selectVersion').hide();

			updatePlatforms(null, thisProduct);

		} else {
			var selVersion = $('input[name=version]:checked').val();

			if (selVersion) {
				var release = window.allReleases[selVersion];

				updatePlatforms(release, thisProduct);
			}

			fadeIn($('#selectVersion'), false);
		}

		if (thisProduct == 'it') {
			/// Requirements panels
			$('#requirements, #requirementsITP, #requirementsGamut, #divRequestGamut, #itpDownloadInfo').hide();
			fadeIn($('#requirementsIT, #divDownloadFull, #divDownloadUpgrade, #divRequestTrial, #divDownloadInfo, #upgradeInfo, #fullVersionInfo'), true);
		} else if (thisProduct == 'itp') {
			/// Requirements panels
			$('#requirements, #requirementsIT, #requirementsGamut, #divDownloadUpgrade, #divRequestGamut, #upgradeInfo, #fullVersionInfo').hide();
			fadeIn($('#requirementsITP, #divDownloadFull, #divRequestTrial, #divDownloadInfo, #itpDownloadInfo'), true);
		} else if (thisProduct == 'gamut') {
			if (window.downloadPageType == 'gamut') {
				$('#divDownloadUpgrade, #divRequestTrial, #divDownloadInfo').hide();

				/// Requirements panels
				$('#requirements, #requirementsIT, #requirementsITP').hide();
				fadeIn($('#divDownloadFull, #requirementsGamut, #divRequestGamut'), true);
			} else {
				$('#divDownloadFull, #divDownloadUpgrade, #divRequestTrial, #divDownloadInfo').hide();

				/// Requirements panels
				$('#requirements, #requirementsIT, #requirementsITP').hide();
				fadeIn($('#requirementsGamut, #divRequestGamut'), true);
			}
		} else {
			/// Requirements panels
			$('#requirementsIT, #requirementsITP, #requirementsGamut, #divRequestGamut, #itpDownloadInfo').hide();
			fadeIn($('#requirements, #divDownloadFull, #divDownloadUpgrade, #divRequestTrial, #divDownloadInfo, #upgradeInfo, #fullVersionInfo'), true);

		}
	});

	function updatePlatforms(release, product)
	{
		var platformExpr = '';
		if (product == 'it') {
			platformExpr = '#' + release.ITPlatforms.join(', #');
		} else if (product == 'itp') {
			platformExpr = '#' + release.ITPPlatforms.join(', #');
		}
		else if (product == 'gamut') {
			platformExpr = '#win32';
		}
		else {
			platformExpr = '#' + release.Platforms.join(', #');
		}

		/// Toggle platforms based on release
		jQuery('input:radio[name="platform"]').not(platformExpr).parent().hide();

		jQuery(platformExpr).each(function (i, el) {
			fadeIn(jQuery(el).parent(), false);
		});

	}

	$('input:radio[name="version"]').click(function (event) {
		var selVersion = $(this).attr('value');


		var selProd = $('input[name=product]:checked').val();
		var release = window.allReleases[selVersion];

		if (selProd) {
			updatePlatforms(release, selProd);
		}

		var requirements = release.Requirements;

		/// Toggle the version information panel
		$('div[id^="version_"]').not('[id="release_' + selVersion + '"]').hide();
		fadeIn($('#version_' + selVersion), true);


		/// Toggle the download buttons.
		if (release.HasUpgrade && selProd != 'itp') {
			fadeIn($('.downloadUpgrade'), false);
			$('#upgradeInfo').html(release.UpgradeInfo);
			fadeIn($('#upgradeInfo'), true);
		} else {
			$('.downloadUpgrade, #upgradeInfo').hide();
		}

		/// Toggle the download info panels
		if (release.HasFullVersion && selProd != 'itp') {
			$('#fullVersionInfo').html(release.FullVersionInfo);
			fadeIn($('#fullVersionInfo'), true);
		} else {
			$('#fullVersionInfo').hide();
		}

		if (release.HasIS)
		{
			fadeIn($('#prod_is'), false);
		}
		else
		{
			fadeOut($('#prod_is'));
			if (selProd == 'is')
			{
				$('#master').click();
			}
		}

		if (release.HasITP) {
			fadeIn($('#prod_itp'), false);
		}
		else {
			fadeOut($('#prod_itp'));
			if (selProd == 'itp') {
				$('#it').click();
			}
		}

		/// Set the Requirements Info
		$('#requirementsOS').html(requirements.OS);
		$('#requirementsRAM').html(requirements.RAM);
		$('#requirementsHardDrive').html(requirements.HardDrive);

		requirements = release.RequirementsIT;

		$('#requirementsITOS').html(requirements.OS);
		$('#requirementsITRAM').html(requirements.RAM);
		$('#requirementsITHardDrive').html(requirements.HardDrive);

		requirements = release.RequirementsITP;

		$('#requirementsITPOS').html(requirements.OS);
		$('#requirementsITPRAM').html(requirements.RAM);
		$('#requirementsITPHardDrive').html(requirements.HardDrive);

	});

	$('#btnDownloadTrial').click(function (event) {

		downloadClicked(DOWNLOAD_TRIAL);
	});
	$('#btnDownloadFull').click(function (event) {
		downloadClicked(DOWNLOAD_FULL);
	});
	$('#btnDownloadUpgrade').click(function (event) {
		downloadClicked(DOWNLOAD_UPGRADE);
	});

	$('#btnRequestTrial').click(function (event) {

		var selProd = $('input[name=product]:checked').val();
		var product = window.allProducts[selProd];

		if (product && product.TrialUrl) {
			window.open(product.TrialUrl, '_blank');
		}
	});

	if (window.downloadPageType == 'gamut') {
		$('#gamut').first().click();
	}
	else {
		var prod = getParameterByName('product');

		switch (prod) {
			case 'Image_Sensor':
			case 'ImageSensor':
				$('#is').first().click();
				break;
			case 'Studio':
				$('#studio').first().click();
				break;
			case 'IT':
				$('#it').first().click();
				break;
			case 'Master':
			default:

				$('#master').first().click();
				break;
		}
	}

	var version = getParameterByName('version');
	if (version && $('#' + version).length > 0) {
		if($.contains($('legacyReleases'), $('#' + version)))
		{
			$('#lnkPreviousReleases').click();
		}

		$('#' + version).click();
	}
	else {
		$('input:radio[name="version"]').first().click();
	}

	if (window.downloadPageType == 'gamut') {
		$('#win32').first().click();
	}
	else {
		if (plat.search(/Mac/) != -1) {
			$('input:radio[id$="osx"]').each(function (index, el) {
				$(this).prop('checked', true);
			});
			$('#MacWarning').show();
		} else if (plat.search(/Linux/) != -1) {
			$('input:radio[id$="linux"]').each(function (index, el) {
				$(this).prop('checked', true);
			});
			$('#MacWarning').hide();
		} else if (plat.search(/Win/) != -1) {
			$('input:radio[id$="win64"]').each(function (index, el) {
				$(this).prop('checked', true);
			});
			$('#MacWarning').hide();
		}
	}
});

function downloadClicked(type) {
	var selProdEl = $('input[name=product]:checked');
	var selVersionEl = $('input[name=version]:checked');
	var selPlatEl = $('input[name=platform]:checked');

	if (selProdEl.length == 0 || !selProdEl.parent().is(':visible')) {
		alert('Please select a product first.');
		return;
	}

	if (window.downloadPageType != 'gamut' && (selVersionEl.length == 0 || !selVersionEl.parent().is(':visible'))) {
		alert('Please select a release version first.');
		return;
	}

	if (selPlatEl.length == 0 || !selPlatEl.parent().is(':visible')) {
		alert('Please select an operating system first.');
		return;
	}

	var selProd = selProdEl.val();
	var selVersion = selVersionEl.val();
	var selPlat = selPlatEl.val();

	var version = window.allReleases[selVersion];
	var platform = window.allPlatforms[selPlat];


	var url = '';

	if (selProd === 'gamut')
	{
		url = 'http://www.imatest.com/gamutvision-download';
	}
	else {
		if (downloadPageType == 'full' || downloadPageType == 'trial') {
			if (type == DOWNLOAD_FULL || type == DOWNLOAD_TRIAL) {
				if (version.CurrentVersion) {
					url = 'http://www.imatest.com/' + selProd + platform.UrlCode + '-download';
				} else {
					url = 'http://www.imatest.com/' + selProd + '-' + version.MajorVersion + platform.UrlCode + '-download';
				}
			} else if (type == DOWNLOAD_UPGRADE) {
				if (version.CurrentVersion) {
					url = 'http://www.imatest.com/' + selProd + platform.UrlCode + '-upgrade-download';
				} else {
					url = 'http://www.imatest.com/' + selProd + '-' + version.MajorVersion + platform.UrlCode + '-upgrade-download';
				}
			}
		}
		else if(downloadPageType == 'beta')
		{
			if (type == DOWNLOAD_FULL) {

				url = 'http://www.imatest.com/' + selProd + '-beta-download' + platform.UrlCode;
			}
			else if (type == DOWNLOAD_UPGRADE) {
				url = 'http://www.imatest.com/' + selProd + '-beta-upgrade-download' + platform.UrlCode;
			}
		}
	}

	// console.debug(url);
	// return;
	if (window.downloadPageType == 'beta')
	{
		type = DOWNLOAD_BETA;
	}

	sendDownloadEvent(type, selProd, selPlat);

	window.open(url, '_blank');

	return;
	//window.location = thankYouUrl;
}

function sendDownloadEvent(type, product, os) {
	var action = '';
	var label = '';

	switch (product) {
		case 'master':
			action = 'Master';
			break;
		case 'is':
			action = 'Image Sensor';
			break;
		case 'it':
			action = 'IT';
			break;
		case 'studio':
			action = 'Studio';
			break;
		case 'gamut':
			action = 'Gamutvision';
			break;
		default:
			action = '[Unknown]';
			break;
	}

	switch (os)
	{
		case 'x64':
		case 'win64':
			label = 'Windows x64';
			break;
		case 'x86':
		case 'win32':
			label = 'Windows x86';
			break;
		case 'linux':
			label = 'Linux';
			break;
		case 'osx':
			label = 'OSX';
			break;
		default:
			label = '[Unknown]';
			break;
	}
	if (typeof ga !== 'undefined' && ga) {
		ga('send', 'event', type, action, label);
	}
}

function getParameterByName(name) {
	var match = RegExp('[?&]' + name + '=([^&]*)').exec(window.location.search);
	return match && decodeURIComponent(match[1].replace(/\+/g, ' '));
}

